///////////////////////////////////////////////////////////
// DLLMain.cpp
//
///////////////////////////////////////////////////////////
// Defines the entry point to the shared lib on windows
///////////////////////////////////////////////////////////
//  Created on: May 26, 2009
//      Author: Scott Ostapovicz
///////////////////////////////////////////////////////////

#include "curl/curl.h"

#ifdef WIN32

#ifdef _MANAGED
#pragma managed(push, off)
#endif

BOOL APIENTRY
DllMain (HMODULE hModule,
         DWORD  ul_reason_for_call,
         LPVOID lpReserved)
{
	BOOL vRetVal = TRUE;

	switch (ul_reason_for_call)
	{
		// Initialize libcurl when library is first loaded
		case DLL_PROCESS_ATTACH:
		{
			int status = curl_global_init(CURL_GLOBAL_ALL);
			if ( status != 0 ) // non-zero return indicates error
				vRetVal = FALSE;
		}
		break;

		// unload libcurl (and relase resources) when dll is unloaded
		case DLL_PROCESS_DETACH:
			curl_global_cleanup();
		break;

		// no-op for thread attach or detach
		default:
		break;
	}
	return vRetVal;
}

#ifdef _MANAGED
#pragma managed(pop)
#endif

#endif // WIN32

