#ifndef XAM_ERRORS_H
#define XAM_ERRORS_H 1
////////////////////////////////////////////////////////////////////////////////
//  Copyright (c) 2007, The Storage Networking Industry Association.
//
//  Redistribution and use in source and binary forms, with or without 
//  modification, are permitted provided that the following conditions 
//  are met:
//    - Redistributions of source code must retain the above copyright notice, 
//      this list of conditions and the following disclaimer.
//    - Redistributions in binary form must reproduce the above copyright 
//      notice, this list of conditions and the following disclaimer in the 
//      documentation and/or other materials provided with the distribution.
//    - Neither the name of The Storage Networking Industry Association (SNIA)
//      nor the names of its contributors may not be used to endorse or promote 
//      products derived from this software without specific prior written 
//      permission.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
//  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
//  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
//  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
//  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
//  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
//  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
//  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
//  THE POSSIBILITY OF SUCH DAMAGE.
// ============================================================================
//  Copyright (c) 2007, EMC Corporation.
//
//  Redistribution and use in source and binary forms, with or without 
//  modification, are permitted provided that the following conditions 
//  are met:
//    - Redistributions of source code must retain the above copyright notice, 
//      this list of conditions and the following disclaimer.
//    - Redistributions in binary form must reproduce the above copyright 
//      notice, this list of conditions and the following disclaimer in the 
//      documentation and/or other materials provided with the distribution.
//    - The name of EMC Corporation may not be used to endorse or promote 
//      products derived from this software without specific prior written 
//      permission.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
//  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
//  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
//  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
//  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
//  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
//  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
//  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
//  THE POSSIBILITY OF SUCH DAMAGE.
////////////////////////////////////////////////////////////////////////////////
//  XAM SDK Source File Build Version @version.full@
////////////////////////////////////////////////////////////////////////////////

/* ===================================================================== *\
 *               standard error codes  returned by the XAM API           *
\* ===================================================================== */

#define XAM_UNKNOWN_ERROR                 1001   /**< An unknown error occured */
#define XAM_OUT_OF_MEMORY                 1002   /**< Out of memory */
#define XAM_INVALID_PARAM                 1003   /**< Encountered an invalid API parameter */
#define XAM_PARAM_NOT_UTF8                1004   /**< Parameter found not to be UTF-8 */
#define XAM_INVALID_HANDLE                1005   /**< Invalid handle parameter */
#define XAM_INVALID_MIME_TYPE             1006   /**< Invalid mime type */
#define XAM_INVALID_XSTREAM_MODE          1007   /**< Invalid XStream mode */
#define XAM_INVALID_XRI                   1008   /**< Invalid XRI */
#define XAM_INVALID_XSET_MODE             1009   /**< Invalid operating mode for the XSet */
#define XAM_INVALID_FIELD_NAME            1010   /**< The specified field name is invalid */
#define XAM_VIM_NOT_FOUND                 1011   /**< VIM could not be located or loaded */
#define XAM_VIM_SYMBOL_NOT_FOUND          1012   /**< Required symbol not found in VIM */
#define XAM_FIELD_NOT_FOUND               1013   /**< Field not found for a given handle */
#define XAM_FIELD_IS_READ_ONLY            1014   /**< Attempted to write to a read only field */
#define XAM_FIELD_EXISTS                  1015   /**< Field already exists */
#define XAM_FIELD_IN_USE                  1016   /**< Field in use error */
#define XAM_MAX_FIELDS_EXCEEDED           1017   /**< Too many fields exist in this object */
#define XAM_FILESYSTEM_ERROR              1018   /**< Filesystem error */
#define XAM_XSYSTEM_ABANDONED             1019   /**< The XSystem instance has been abandoned */
#define XAM_XSET_ABANDONED                1020   /**< The XSet instance has been abandoned */
#define XAM_XSTREAM_ABANDONED             1021   /**< The XStream instance has been abandoned */
#define XAM_XSYSTEM_CORRUPT               1022   /**< The XSystem instance has been corrupted */
#define XAM_XSET_CORRUPT                  1023   /**< The XSet instance has been corrupted */
#define XAM_XSTREAM_CORRUPT               1024   /**< The XStream instance has been corrupted */
#define XAM_CONNECT_FAILED                1025   /**< Failed to connect to the XSystem */
#define XAM_AUTH_REQUIRED                 1026   /**< Authentication is required */
#define XAM_AUTH_DATA_NEEDED              1027   /**< Additional authentication data is required */
#define XAM_AUTH_FAILED                   1028   /**< Authentication failed */
#define XAM_BAD_XUID_FORMAT               1029   /**< Bad XUD format */
#define XAM_XSET_INACCESSIBLE             1030   /**< The XSet was inaccessible */
#define XAM_XASYNC_PENDING                1031   /**< Asynchronous operation is pending */
#define XAM_NOT_SUPPORTED                 1032   /**< The operation requested is not supported */
#define XAM_OPERATION_NOT_ALLOWED         1033   /**< Operation not allowed */
#define XAM_OBJECT_IN_USE                 1034   /**< This object is currently in use */
#define XAM_NOT_A_JOB                     1035   /**< The XSet does not contain a job request */
#define XAM_JOB_INVALID_CMD               1036   /**< The job command is invalid */  
#define XAM_JOB_INVALID_CMD_SYNTAX        1037   /**< The job command syntax is invalid */
#define XAM_JOB_LEVEL_NOT_SUPPORTED       1038   /**< The job level is insufficent */
#define XAM_JOB_INSUFFICIENT_PERMISSIONS  1039   /**< The job permissions are insuffient */
#define XAM_JOB_INSUFFICIENT_RESOURCES    1040   /**< The job resources are insufficent */
#define XAM_JOB_RUNNING                   1041   /**< A job is already running */
#define XAM_XSET_UNDER_RETENTION          1042   /**< The XSet is under retention */
#define XAM_XSET_UNDER_HOLD               1043   /**< The XSet is under hold and cannot be deleted */
#define XAM_XSET_INVALID_HOLD_ID          1044   /**< The hold id is invalid */
#define XAM_XSET_INVALID_RETENTION_VALUE  1045   /**< Invalid retention value or sequence */
#define XAM_INVALID_POLICY_NAME           1046   /**< Invalid policy name for this operation */
#define XAM_XASYNC_HALTED                 1047   /**< The async operation was halted */
#define XAM_INVALID_POLICY_VALUE          1048   /**< Invalid policy value for this operation */
#endif // XAM_ERRORS_H





