#ifndef XAM_STRINGS_H
#define XAM_STRINGS_H 1
////////////////////////////////////////////////////////////////////////////////
//  Copyright (c) 2007, The Storage Networking Industry Association.
//
//  Redistribution and use in source and binary forms, with or without 
//  modification, are permitted provided that the following conditions 
//  are met:
//    - Redistributions of source code must retain the above copyright notice, 
//      this list of conditions and the following disclaimer.
//    - Redistributions in binary form must reproduce the above copyright 
//      notice, this list of conditions and the following disclaimer in the 
//      documentation and/or other materials provided with the distribution.
//    - Neither the name of The Storage Networking Industry Association (SNIA)
//      nor the names of its contributors may not be used to endorse or promote 
//      products derived from this software without specific prior written 
//      permission.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
//  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
//  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
//  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
//  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
//  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
//  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
//  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
//  THE POSSIBILITY OF SUCH DAMAGE.
// ============================================================================
//  Copyright (c) 2007, EMC Corporation.
//
//  Redistribution and use in source and binary forms, with or without 
//  modification, are permitted provided that the following conditions 
//  are met:
//    - Redistributions of source code must retain the above copyright notice, 
//      this list of conditions and the following disclaimer.
//    - Redistributions in binary form must reproduce the above copyright 
//      notice, this list of conditions and the following disclaimer in the 
//      documentation and/or other materials provided with the distribution.
//    - The name of EMC Corporation may not be used to endorse or promote 
//      products derived from this software without specific prior written 
//      permission.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
//  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
//  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
//  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
//  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
//  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
//  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
//  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
//  THE POSSIBILITY OF SUCH DAMAGE.
////////////////////////////////////////////////////////////////////////////////
//  XAM SDK Source File Build Version @version.full@
////////////////////////////////////////////////////////////////////////////////

/* ===================================================================== *\
 *                       environment variable names                      *
\* ===================================================================== */

static const char* const XAM_VIM_PATH_ENV_VAR    = "XAM_VIM_PATH";

/* ===================================================================== *\
 *                       connection string elements                      *
\* ===================================================================== */

static const char* const XAM_PROTOCOL            = "snia-xam://";
static const char* const XAM_VIM_LIBRARY_TOKEN   = "!";

/* ===================================================================== *\
 *                              stypes                                   *
\* ===================================================================== */

static const char* const XAM_BOOLEAN_MIME_TYPE   = "application/vnd.snia.xam.boolean";
static const char* const XAM_INT_MIME_TYPE       = "application/vnd.snia.xam.int";
static const char* const XAM_DOUBLE_MIME_TYPE    = "application/vnd.snia.xam.double";
static const char* const XAM_XUID_MIME_TYPE      = "application/vnd.snia.xam.xuid";
static const char* const XAM_STRING_MIME_TYPE    = "application/vnd.snia.xam.string";
static const char* const XAM_DATETIME_MIME_TYPE  = "application/vnd.snia.xam.datetime";

/* ===================================================================== *\
 *                       Misc XStream MIME Types                         *
\* ===================================================================== */

static const char* const XAM_DEFAULT_MIME_TYPE          = "application/octet-stream";
static const char* const XAM_TEXT_PLAIN_MIME_TYPE       = "text/plain";
static const char* const XAM_QUERY_XUID_LIST_MIME_TYPE  = "application/vnd.snia.query.xuid_list";

/* =================================================================== *\
 *                   XSet create/open mode strings                     *
\* =================================================================== */

static const char* const XSET_MODE_READ_ONLY  = "readonly";
static const char* const XSET_MODE_RESTRICTED = "restricted";
static const char* const XSET_MODE_MODIFY     = "unrestricted";

/* =================================================================== *\
 *                   XStream open mode strings                         *
\* =================================================================== */

static const char* const XSTREAM_MODE_READ_ONLY          = "readonly";
static const char* const XSTREAM_MODE_WRITEONLY_TRUNCATE = "writeonly";
static const char* const XSTREAM_MODE_WRITEONLY_APPEND   = "appendonly";

/* ===================================================================== *\
 *                         XAM object field names                        *
\* ===================================================================== */

static const char* const XAM_IDENTITY           = ".xam.identity";
static const char* const XAM_API_LEVEL          = ".xam.apiLevel";
static const char* const XAM_VIM_LIST           = ".xam.vim.list";
static const char* const XAM_MAX_STRING_FIELD   = ".xam.maxstring";

/* ===================================================================== *\
 *                 XAM library configuration field names                 *
\* ===================================================================== */

static const char* const XAM_CONFIG_PATH        = ".xam.config.path";

/* ===================================================================== *\
 *                 XAM library logging control field names               *
\* ===================================================================== */

static const char* const XAM_LOG_LEVEL          = ".xam.log.level";
static const char* const XAM_LOG_VERBOSITY      = ".xam.log.verbosity";
static const char* const XAM_LOG_PATH           = ".xam.log.path";

/* ===================================================================== *\
 *                XAM library log configuration field names              *
\* ===================================================================== */

static const char* const XAM_LOG_FORMAT             = ".xam.log.format";
static const char* const XAM_LOG_APPEND             = ".xam.log.append";
static const char* const XAM_LOG_MAX_SIZE           = ".xam.log.max.size";
static const char* const XAM_LOG_MAX_ROLLOVERS      = ".xam.log.max.rollovers";
static const char* const XAM_LOG_MSG_FILTER         = ".xam.log.message.filter";
static const char* const XAM_LOG_COMP_FILTER        = ".xam.log.component.filter";

/* ===================================================================== *\
 *                        XSystem field names                            *
\* ===================================================================== */

static const char* const XAM_XSYSTEM_INITIALIZING         = ".xsystem.initializing";

static const char* const XAM_XSYSTEM_IDENTITY             = ".xsystem.identity";
static const char* const XAM_XSYSTEM_TIME                 = ".xsystem.time";
static const char* const XAM_XSYSTEM_MAX_FIELDS           = ".xsystem.limits.maxFieldsPerXSet";
static const char* const XAM_XSYSTEM_MAX_SIZE_OF_XSTREAM  = ".xsystem.limits.maxSizeOfXStream";
static const char* const XAM_XSYSTEM_SASL_LIST            = ".xsystem.auth.SASLmechanism.list";
static const char* const XAM_XSYSTEM_SASL_DEFAULT         = ".xsystem.auth.SASLmechanism.default";

static const char* const XAM_XSYSTEM_AUTH_GRANULE_LIST               = ".xsystem.auth.granule.list";
static const char* const XAM_XSYSTEM_AUTH_IDENTITY_AUTHENTICATION    = ".xsystem.auth.identity.authentication";
static const char* const XAM_XSYSTEM_AUTH_IDENTITY_AUTHORIZATION     = ".xsystem.auth.identity.authorization";
static const char* const XAM_XSYSTEM_AUTH_EXPIRATION                 = ".xsystem.auth.expiration";

static const char* const XAM_XSYSTEM_ACCESS                          = ".xsystem.access";
static const char* const XAM_XSYSTEM_ACCESS_POLICY_LIST              = ".xsystem.access.policy.list";
static const char* const XAM_XSYSTEM_MANAGEMENT_POLICY_LIST          = ".xsystem.management.policy.list";
static const char* const XAM_XSYSTEM_MANAGEMENT_POLICY_DEFAULT       = ".xsystem.management.policy.default";
static const char* const XAM_XSYSTEM_STORAGE_POLICY_LIST             = ".xsystem.storage.policy.list";

static const char* const XAM_XSYSTEM_JOB_COMMIT_SUPPORTED            = ".xsystem.job.commit.supported";
static const char* const XAM_XSYSTEM_JOB_LIST                        = ".xsystem.job.list"; 
static const char* const XAM_XSYSTEM_JOB_LIST_QUERY                  = ".xsystem.job.list.xam.job.query";
static const char* const XAM_XSYSTEM_JOB_QUERY_CONTINUANCE_SUPPORTED = ".xsystem.job.xam.job.query.continuance.supported";
static const char* const XAM_XSYSTEM_JOB_QUERY_LEVEL1_SUPPORTED      = ".xsystem.job.xam.job.query.level1.supported";
static const char* const XAM_XSYSTEM_JOB_QUERY_LEVEL2_SUPPORTED      = ".xsystem.job.xam.job.query.level2.supported";

static const char* const XAM_XSYSTEM_AUTODELETE                      = ".xsystem.deletion.autodelete";
static const char* const XAM_XSYSTEM_AUTODELETE_POLICY_LIST          = ".xsystem.deletion.autodelete.policy.list";
static const char* const XAM_XSYSTEM_SHRED                           = ".xsystem.deletion.shred";
static const char* const XAM_XSYSTEM_SHRED_POLICY_LIST               = ".xsystem.deletion.shred.policy.list";

static const char* const XAM_XSYSTEM_RETENTION_ENABLED_POLICY_LIST   = ".xsystem.retention.enabled.policy.list";
static const char* const XAM_XSYSTEM_RETENTION_DURATION_POLICY_LIST  = ".xsystem.retention.duration.policy.list";


/* ==================================================================== *\
 *                        XSet basic field names                        *
\* ==================================================================== */

static const char* const XAM_XSET_TIME_CREATION      = ".xset.time.creation";
static const char* const XAM_XSET_TIME_XUID          = ".xset.time.xuid";
static const char* const XAM_XSET_TIME_COMMIT        = ".xset.time.commit";
static const char* const XAM_XSET_TIME_ACCESS        = ".xset.time.access";
static const char* const XAM_XSET_TIME_RESIDENCY     = ".xset.time.residency";
static const char* const XAM_XSET_XUID               = ".xset.xuid";
static const char* const XAM_XSET_DIRTY              = ".xset.dirty";

/* =================================================================== *\
 *                   XSet management field names                       *
\* =================================================================== */

static const char* const XAM_XSET_ACCESS_POLICY                = ".xset.access.policy";
static const char* const XAM_XSET_MANAGEMENT_POLICY            = ".xset.management.policy";
static const char* const XAM_XSET_STORAGE_POLICY               = ".xset.storage.policy";

static const char* const XAM_XSET_RETENTION_LIST               = ".xset.retention.list";

static const char* const XAM_XSET_RETENTION_BASE_ENABLED         = ".xset.retention.base.enabled";
static const char* const XAM_XSET_RETENTION_BASE_START_TIME      = ".xset.retention.base.starttime";
static const char* const XAM_XSET_RETENTION_BASE_DURATION        = ".xset.retention.base.duration";
static const char* const XAM_XSET_RETENTION_BASE_ENABLED_POLICY  = ".xset.retention.base.enabled.policy";
static const char* const XAM_XSET_RETENTION_BASE_DURATION_POLICY = ".xset.retention.base.duration.policy";

static const char* const XAM_XSET_RETENTION_EVENT_ENABLED         = ".xset.retention.event.enabled";
static const char* const XAM_XSET_RETENTION_EVENT_START_TIME      = ".xset.retention.event.starttime";
static const char* const XAM_XSET_RETENTION_EVENT_DURATION        = ".xset.retention.event.duration";
static const char* const XAM_XSET_RETENTION_EVENT_ENABLED_POLICY  = ".xset.retention.event.enabled.policy";
static const char* const XAM_XSET_RETENTION_EVENT_DURATION_POLICY = ".xset.retention.event.duration.policy";

static const char* const XAM_XSET_DELETION_AUTODELETE             = ".xset.deletion.autodelete";
static const char* const XAM_XSET_DELETION_AUTODELETE_POLICY      = ".xset.deletion.autodelete.policy";
static const char* const XAM_XSET_DELETION_SHRED                  = ".xset.deletion.shred";
static const char* const XAM_XSET_DELETION_SHRED_POLICY           = ".xset.deletion.shred.policy";

static const char* const XAM_XSET_HOLD                         = ".xset.hold";
static const char* const XAM_XSET_HOLD_LIST                    = ".xset.hold.list";

/* ==================================================================== *\
 *                  XSet Job Properties/Values field names              *
\* ==================================================================== */

static const char* const XAM_JOB_COMMAND                 = "org.snia.xam.job.command";
static const char* const XAM_JOB_STATUS                  = ".xam.job.status";

static const char* const XAM_JOB_STATUS_NEW              = "NEW";
static const char* const XAM_JOB_STATUS_STARTING         = "STARTING";
static const char* const XAM_JOB_STATUS_RUNNING          = "RUNNING";
static const char* const XAM_JOB_STATUS_SHUTTING_DOWN    = "SHUTTING DOWN";
static const char* const XAM_JOB_STATUS_COMPLETE         = "COMPLETE";
static const char* const XAM_JOB_STATUS_SUSPENDED        = "SUSPENDED";
static const char* const XAM_JOB_STATUS_HALTED           = "HALTED";
static const char* const XAM_JOB_STATUS_KILLED           = "KILLED";

static const char* const XAM_JOB_ERRORHEALTH             = ".xam.job.errorhealth";
static const char* const XAM_JOB_ERRORHEALTH_OK          = "OK";
static const char* const XAM_JOB_ERRORHEALTH_ERROR       = "ERROR";

static const char* const XAM_JOB_ERROR                   = ".xam.job.error";

/* ===================================================================== *\
 *                     XSet job command values                           *
\* ===================================================================== */

static const char* const XAM_JOB_QUERY                   = "xam.job.query";

/* ===================================================================== *\
 *                     XSet Query Job field names                        *
\* ===================================================================== */

static const char* const XAM_JOB_QUERY_COMMAND           = "xam.job.query.command";
static const char* const XAM_JOB_QUERY_RESULTS           = "xam.job.query.results";
static const char* const XAM_JOB_QUERY_RESULTS_COUNT     = "xam.job.query.results.count";
static const char* const XAM_JOB_QUERY_LEVEL             = "xam.job.query.level";
	
static const char* const XAM_JOB_QUERY_LEVEL_1           = "org.snia.xam.job.query.level.1";
static const char* const XAM_JOB_QUERY_LEVEL_2           = "org.snia.xam.job.query.level.2";

/* ===================================================================== *\
 *                       XAM job error tokens                            *
\* ===================================================================== */

static const char* const XAM_JOB_ERROR_NOT_A_JOB                 = "org.snia.xam::not_a_job";
static const char* const XAM_QUERY_ERROR_UNSPECIFIED_CMD         = "org.snia.xam.query::unspecified_command";
static const char* const XAM_QUERY_ERROR_LEVEL_NOT_SUPPORTED     = "xam.job.query::level_not_supported";
static const char* const XAM_QUERY_ERROR_INVALID_CMD_SYNTAX      = "xam.job.query::invalid_command_syntax";
static const char* const XAM_QUERY_ERROR_INSUFFICIENT_PERMISSION = "xam.job.query::insufficient_permission";
static const char* const XAM_QUERY_ERROR_INSUFFICIENT_RESOURCES  = "xam.job.query::insufficient_resources";

/* ===================================================================== *\
 *                       XAM error tokens                                *
\* ===================================================================== */

static const char* const XAM_OK_TOKEN                    = "xam/OK";
static const char* const XAM_UNKNOWN_ERROR_TOKEN         = "xam/unknown error";
static const char* const XAM_OUT_OF_MEMORY_TOKEN         = "xam/out of memory";
static const char* const XAM_INVALID_PARAM_TOKEN         = "xam/invalid parameter";
static const char* const XAM_PARAM_NOT_UTF8_TOKEN        = "xam/non-UTF8 parameter";
static const char* const XAM_INVALID_HANDLE_TOKEN        = "xam/invalid handle";
static const char* const XAM_INVALID_MIME_TYPE_TOKEN     = "xam/invalid mime type";
static const char* const XAM_INVALID_XSTREAM_MODE_TOKEN  = "xam/invalid xstream mode";
static const char* const XAM_INVALID_XRI_TOKEN           = "xam/invalid XRI";
static const char* const XAM_INVALID_XSET_MODE_TOKEN     = "xam/invalid xset mode";
static const char* const XAM_INVALID_FIELD_NAME_TOKEN    = "xam/invalid field name";
static const char* const XAM_VIM_NOT_FOUND_TOKEN         = "xam/vim not found";
static const char* const XAM_VIM_SYMBOL_NOT_FOUND_TOKEN  = "xam/vim symbol not found";
static const char* const XAM_FIELD_NOT_FOUND_TOKEN       = "xam/field not found";
static const char* const XAM_FIELD_IS_READ_ONLY_TOKEN    = "xam/field is read only";
static const char* const XAM_FIELD_EXISTS_TOKEN          = "xam/field exists";
static const char* const XAM_FIELD_IN_USE_TOKEN          = "xam/field in use";
static const char* const XAM_MAX_FIELDS_EXCEEDED_TOKEN   = "xam/reached maximum field limit";
static const char* const XAM_FILESYSTEM_ERROR_TOKEN      = "xam/filesystem error";
static const char* const XAM_XSYSTEM_ABANDONED_TOKEN     = "xam/xsystem abandoned";
static const char* const XAM_XSET_ABANDONED_TOKEN        = "xam/xset abandoned";
static const char* const XAM_XSTREAM_ABANDONED_TOKEN     = "xam/xstream abandoned";
static const char* const XAM_XSYSTEM_CORRUPT_TOKEN       = "xam/xsystem corrupted";
static const char* const XAM_XSET_CORRUPT_TOKEN          = "xam/xset corrupted";
static const char* const XAM_XSTREAM_CORRUPT_TOKEN       = "xam/xstream corrupted";
static const char* const XAM_CONNECT_FAILED_TOKEN        = "xam/connection failed";
static const char* const XAM_AUTH_REQUIRED_TOKEN         = "xam/authentication required";
static const char* const XAM_AUTH_DATA_NEEDED_TOKEN      = "xam/authentication data needed";
static const char* const XAM_AUTH_FAILED_TOKEN           = "xam/authentication failed";
static const char* const XAM_BAD_XUID_FORMAT_TOKEN       = "xam/bad xuid format";
static const char* const XAM_XSET_INACCESSIBLE_TOKEN     = "xam/xset inaccessible";
static const char* const XAM_XASYNC_PENDING_TOKEN        = "xam/async operation pending";
static const char* const XAM_NOT_SUPPORTED_TOKEN         = "xam/operation not supported";
static const char* const XAM_OPERATION_NOT_ALLOWED_TOKEN = "xam/operation not allowed";
static const char* const XAM_OBJECT_IN_USE_TOKEN         = "xam/object in use";
static const char* const XAM_NOT_A_JOB_TOKEN             = "xam/not a job";
static const char* const XAM_JOB_INVALID_CMD_TOKEN       = "xam/job command invalid";
static const char* const XAM_JOB_INVALID_CMD_SYNTAX_TOKEN = "xam/job invalid command syntax";
static const char* const XAM_JOB_LEVEL_NOT_SUPPORTED_TOKEN      = "xam/job level not supported";
static const char* const XAM_JOB_INSUFFICIENT_PERMISSIONS_TOKEN = "xam/job insufficent permissions";
static const char* const XAM_JOB_INSUFFICIENT_RESOURCES_TOKEN   = "xam/job insufficent resources";
static const char* const XAM_JOB_RUNNING_TOKEN           = "xam/job already running";
static const char* const XAM_XSET_UNDER_RETENTION_TOKEN  = "xam/xset is under retention";        
static const char* const XAM_XSET_UNDER_HOLD_TOKEN       = "xam/xset is under hold";               
static const char* const XAM_XSET_INVALID_HOLD_ID_TOKEN   = "xam/invalid hold id";           
static const char* const XAM_XSET_INVALID_RETENTION_VALUE_TOKEN  = "xam/invalid retention value or sequence";
static const char* const XAM_INVALID_POLICY_NAME_TOKEN   = "xam/invalid policy name";
static const char* const XAM_INVALID_POLICY_VALUE_TOKEN   = "xam/policy mismatch";
static const char* const XAM_XASYNC_HALTED_TOKEN         = "xam/async operation halted";

#endif // XAM_STRINGS_H


