#ifndef __XAM_LOGGER__
#define __XAM_LOGGER__
////////////////////////////////////////////////////////////////////////////////
//  Copyright (c) 2007, The Storage Networking Industry Association.
//
//  Redistribution and use in source and binary forms, with or without 
//  modification, are permitted provided that the following conditions 
//  are met:
//    - Redistributions of source code must retain the above copyright notice, 
//      this list of conditions and the following disclaimer.
//    - Redistributions in binary form must reproduce the above copyright 
//      notice, this list of conditions and the following disclaimer in the 
//      documentation and/or other materials provided with the distribution.
//    - Neither the name of The Storage Networking Industry Association (SNIA)
//      nor the names of its contributors may not be used to endorse or promote 
//      products derived from this software without specific prior written 
//      permission.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
//  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
//  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
//  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
//  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
//  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
//  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
//  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
//  THE POSSIBILITY OF SUCH DAMAGE.
// ============================================================================
//  Copyright (c) 2007, EMC Corporation.
//
//  Redistribution and use in source and binary forms, with or without 
//  modification, are permitted provided that the following conditions 
//  are met:
//    - Redistributions of source code must retain the above copyright notice, 
//      this list of conditions and the following disclaimer.
//    - Redistributions in binary form must reproduce the above copyright 
//      notice, this list of conditions and the following disclaimer in the 
//      documentation and/or other materials provided with the distribution.
//    - The name of EMC Corporation may not be used to endorse or promote 
//      products derived from this software without specific prior written 
//      permission.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
//  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
//  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
//  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
//  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
//  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
//  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
//  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
//  THE POSSIBILITY OF SUCH DAMAGE.
////////////////////////////////////////////////////////////////////////////////
//  XAM SDK Source File Build Version @version.full@
////////////////////////////////////////////////////////////////////////////////

#include "XAM_LogTypes.h"
#include "XAM_POSIX.h"
#include "XAM_LogFactory.h"
#include "XAM_LogState.h"

// Macro definitions for speedy logging performance

// FATAL (Fatal error conditions)
#define XAM_LOG_FATAL(MsgComponent, MsgFormat) \
    if(XAM_Logger::isEnabled(LOGLEVEL_FATAL, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_FATAL, MsgComponent, MsgFormat);

#define XAM_LOG_FATAL_P2(MsgComponent, MsgFormat, Param1) \
    if(XAM_Logger::isEnabled(LOGLEVEL_FATAL, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_FATAL, MsgComponent, MsgFormat, Param1);

#define XAM_LOG_FATAL_P3(MsgComponent, MsgFormat, Param1, Param2) \
    if(XAM_Logger::isEnabled(LOGLEVEL_FATAL, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_FATAL, MsgComponent, MsgFormat, Param1, Param2);

// ERROR (potentially non-fatal error conditions)
#define XAM_LOG_ERROR(MsgComponent, MsgFormat) \
    if(XAM_Logger::isEnabled(LOGLEVEL_ERROR, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_ERROR, MsgComponent, MsgFormat);

#define XAM_LOG_ERROR_P2(MsgComponent, MsgFormat, Param1) \
    if(XAM_Logger::isEnabled(LOGLEVEL_ERROR, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_ERROR, MsgComponent, MsgFormat, Param1);

#define XAM_LOG_ERROR_P3(MsgComponent, MsgFormat, Param1, Param2) \
    if(XAM_Logger::isEnabled(LOGLEVEL_ERROR, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_ERROR, MsgComponent, MsgFormat, Param1, Param2);

// WARNING (Possible non-fatal problems)
#define XAM_LOG_WARNING(MsgComponent, MsgFormat) \
    if(XAM_Logger::isEnabled(LOGLEVEL_WARNING, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_WARNING, MsgComponent, MsgFormat);

#define XAM_LOG_WARNING_P2(MsgComponent, MsgFormat, Param1) \
    if(XAM_Logger::isEnabled(LOGLEVEL_WARNING, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_WARNING, MsgComponent, MsgFormat, Param1);

#define XAM_LOG_WARNING_P3(MsgComponent, MsgFormat, Param1, Param2) \
    if(XAM_Logger::isEnabled(LOGLEVEL_WARNING, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_WARNING, MsgComponent, MsgFormat, Param1, Param2);

// INFO (Informational, Normal API level logging)
#define XAM_LOG_INFO(MsgComponent, MsgFormat) \
    if(XAM_Logger::isEnabled(LOGLEVEL_INFO, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_INFO, MsgComponent, MsgFormat);

#define XAM_LOG_INFO_P2(MsgComponent, MsgFormat, Param1) \
    if(XAM_Logger::isEnabled(LOGLEVEL_INFO, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_INFO, MsgComponent, MsgFormat, Param1);

#define XAM_LOG_INFO_P3(MsgComponent, MsgFormat, Param1, Param2) \
    if(XAM_Logger::isEnabled(LOGLEVEL_INFO, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_INFO, MsgComponent, MsgFormat, Param1, Param2);

// DEBUG (Suitable for non-developers to debug problems)
#define XAM_LOG_DEBUG(MsgComponent, MsgFormat) \
    if(XAM_Logger::isEnabled(LOGLEVEL_DEBUG, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_DEBUG, MsgComponent, MsgFormat);

#define XAM_LOG_DEBUG_P2(MsgComponent, MsgFormat, Param1) \
    if(XAM_Logger::isEnabled(LOGLEVEL_DEBUG, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_DEBUG, MsgComponent, MsgFormat, Param1);

#define XAM_LOG_DEBUG_P3(MsgComponent, MsgFormat, Param1, Param2) \
    if(XAM_Logger::isEnabled(LOGLEVEL_DEBUG, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_DEBUG, MsgComponent, MsgFormat, Param1, Param2);

// DEBUG PLUS (Developer level debug logging)
#define XAM_LOG_DEBUG_PLUS(MsgComponent, MsgFormat) \
    if(XAM_Logger::isEnabled(LOGLEVEL_DEBUG_PLUS, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_DEBUG_PLUS, MsgComponent, MsgFormat);

#define XAM_LOG_DEBUG_PLUS_P2(MsgComponent, MsgFormat, Param1) \
    if(XAM_Logger::isEnabled(LOGLEVEL_DEBUG_PLUS, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_DEBUG_PLUS, MsgComponent, MsgFormat, Param1);

#define XAM_LOG_DEBUG_PLUS_P3(MsgComponent, MsgFormat, Param1, Param2) \
    if(XAM_Logger::isEnabled(LOGLEVEL_DEBUG_PLUS, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_DEBUG_PLUS, MsgComponent, MsgFormat, Param1, Param2);

#define XAM_LOG_DEBUG_PLUS_P4(MsgComponent, MsgFormat, Param1, Param2, Param3) \
    if(XAM_Logger::isEnabled(LOGLEVEL_DEBUG_PLUS, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_DEBUG_PLUS, MsgComponent, MsgFormat, Param1, Param2, Param3);

#define XAM_LOG_DEBUG_PLUS_P5(MsgComponent, MsgFormat, Param1, Param2, Param3, Param4) \
    if(XAM_Logger::isEnabled(LOGLEVEL_DEBUG_PLUS, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_DEBUG_PLUS, MsgComponent, MsgFormat, Param1, Param2, Param3, Param4);

// NONE (No associated level, always log)
#define XAM_LOG_ALWAYS(MsgComponent, MsgFormat) \
    if(XAM_Logger::isEnabled(LOGLEVEL_NONE, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_NONE, MsgComponent, MsgFormat);

#define XAM_LOG_ALWAYS_P2(MsgComponent, MsgFormat, Param1) \
    if(XAM_Logger::isEnabled(LOGLEVEL_NONE, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_NONE, MsgComponent, MsgFormat, Param1);

#define XAM_LOG_ALWAYS_P3(MsgComponent, MsgFormat, Param1, Param2) \
    if(XAM_Logger::isEnabled(LOGLEVEL_NONE, MsgComponent)) \
        XAM_Logger::Log(LOGLEVEL_NONE, MsgComponent, MsgFormat, Param1, Param2);

/**
 *   Logging framework class which provides portable, thread safe 
 *   logging capabilities.
 *
 *    The logging mechanism may be configured via:
 *
 *       1. XAM Object fields (XAM API calls)
 *       2. XAM Library Configuration file
 *       3. Environment variables
 */
class XAM_Logger 
{
    /* Allow the register XAM Object fields to modify the logging state */
    friend class XAM_SyntheticLoggingFields;
    /* Allow the log factory to update the active logging state */
    friend class XAM_LogFactory;

    private:

        /* The active logging state (e.g. ON/OFF/UNSET). 
         * Should be updated whenever the application changes the logging 
         * configuration. 
         */
        static LoggingState mLogState;

        /* Instantiating this class here will ensure that the destructor
         * is called when the program exits, so we can clean up our log.
         * This should be the only instantiation of this class.
         */
        static XAM_LogFactory mLogFactory;
        static XAM_Mutex mLoggerLock; // protects mLogFactory

        static char* mMsgBuf;       // The message buffer used to log events
        static xam_int mMsgBufLen;  // The length of the message buffer

        /* The verbosity level of the active logger */
        static xam_int mActiveVerbosityLevel;

        /* The component filter of the active logger */
        static xam_int mActiveComponentFilter;

    public:

        /** 
         *  Get the current logging state.
         *
         *  @return Returns true if logging is turned on,
         *          or if it is uninitialized/unknown.  Returns
         *          false if logging is off.
         */
        static xam_boolean 
        isEnabled () ;

        /**
         *  Determine if the current logging state is active.
         *
         *  @param inLevel The required log level configuration
         *  @param inComponent The required log component
         *  @return Returns true if logging is turned on,
         *          and the current log level/component is 
         *          being logged. Returns false if logging is off.
         */
        static xam_boolean
        isEnabled(const loglevel_t inLevel, const component_t inComponent);

        /**
         * Add infomation to the log
         * @param inLevel     the verbosity level
         * @param inComponent the kind of events we want to log
         * @param inFormat    the event message format string
         * @param ...         parameter list
         */
        static void 
        Log (const loglevel_t inLevel,
             const component_t  inComponent,
             const char *inFormat,
             ...) ;

        /**
         * Enable logging with the provided logging configuration
         *
         * @param inLogState The log configuration to apply
         */
        static void 
        Start(XAM_LogState* inLogState);

        /**
         * Log a message to the application log component (component_app)
         * at the desired log level.
         *
         * @param inLogLevel 
         * @param inMessage
         */
        static void 
        Log(xam_int inLogLevel, const char* inMessage);

        /**
         * Disable all logging
         */
        static xam_status 
        Stop();

        /** 
         * Logs a xam_status to the active log file 
         *
         * If the error code is non-standard, the error token is retrieved from
         * the object referenced by "inHandle".
         *
         * @param inHandle Used to retrieve non-standard tokens
         * @param inStatus The status code to log
         */
        static void 
        logStatus(xam_handle_t inHandle, xam_status inStatus);

    private:

        /*
         * Add infomation to the log.  This routine will also initialize 
         * the logging mechanism, if it has not been initialized yet.
         *
         * @param inLevel     the verbosity level
         * @param inComponent the kind of events we want to log
         * @param inFormat    the event message format string
         * @param ap          parameter list
         * @return true if buffer size was enough for the log message, 
         *         false if buffer was enlarged and parameter list 
         *         has to be reinitialized.
         */
        static xam_boolean 
        logList (const loglevel_t inLevel,
                 const component_t inComponent,
                 const char *inFormat,
                 va_list ap) ;

        /* Initialize the logging mechanism */
        static void 
        initLogging(xam_boolean inObtainLock = true);

        /* Initialize the logging mechanism. 
         * This call requires the mLogger Lock to be held 
         */
        static void 
        initLoggingHelper(XAM_LogFormatter* inLogFormatter);

        /* 
         * Log to the underlying formatter mechanism
         *
         * @param inLevel The log level of this log event
         * @param inComponent Component to log
         * @param inFormat Log format
         * @param ap Argument list
         */
        static xam_boolean 
        logToFormatter(const loglevel_t inLevel, 
                       const component_t inComponent, 
                       const char* inFormat, 
                       va_list ap);

        /* log current logger settings (note, must acquire the mLogger 
         * lock to call this)
         */
        static void 
        logSettings(XAM_LogFormatter* inLogger);

        /**
         * Update the active logging state
         *
         * @param inLogState The active LoggingState
         * @param inLevel The active log level
         * @param inComponentMask The active component mask
         */
        static void 
        setState(LoggingState inLogState, xam_int inLevel, xam_int inComponentMask);

        /**
         * Retrieve the active logging state
         *
         * @return The active LoggingState
         */
        static LoggingState 
        getState();
} ;


#endif // __XAM_LOGGER__



