#ifndef __XAM_VIM__
#define __XAM_VIM__
////////////////////////////////////////////////////////////////////////////////
//  Copyright (c) 2007, The Storage Networking Industry Association.
//
//  Redistribution and use in source and binary forms, with or without 
//  modification, are permitted provided that the following conditions 
//  are met:
//    - Redistributions of source code must retain the above copyright notice, 
//      this list of conditions and the following disclaimer.
//    - Redistributions in binary form must reproduce the above copyright 
//      notice, this list of conditions and the following disclaimer in the 
//      documentation and/or other materials provided with the distribution.
//    - Neither the name of The Storage Networking Industry Association (SNIA)
//      nor the names of its contributors may not be used to endorse or promote 
//      products derived from this software without specific prior written 
//      permission.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
//  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
//  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
//  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
//  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
//  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
//  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
//  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
//  THE POSSIBILITY OF SUCH DAMAGE.
// ============================================================================
//  Copyright (c) 2007, EMC Corporation.
//
//  Redistribution and use in source and binary forms, with or without 
//  modification, are permitted provided that the following conditions 
//  are met:
//    - Redistributions of source code must retain the above copyright notice, 
//      this list of conditions and the following disclaimer.
//    - Redistributions in binary form must reproduce the above copyright 
//      notice, this list of conditions and the following disclaimer in the 
//      documentation and/or other materials provided with the distribution.
//    - The name of EMC Corporation may not be used to endorse or promote 
//      products derived from this software without specific prior written 
//      permission.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
//  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
//  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
//  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
//  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
//  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
//  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
//  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
//  THE POSSIBILITY OF SUCH DAMAGE.
////////////////////////////////////////////////////////////////////////////////
//  XAM SDK Source File Build Version @version.full@
////////////////////////////////////////////////////////////////////////////////

#include "xam_types.h"
#include "vim.h"

namespace { // Anonymous Namespace (only visible within this file)
    extern "C" { // Make sure these names are not mangled

        // VIM API function pointer definitions
        typedef xam_boolean (*XSystem_GetErrorTokenFunc) \
            (const xsystem_handle, \
            const xam_status, \
            xam_string *const);
        typedef xam_status (*XSystem_OpenFieldIteratorFunc) \
            (const xsystem_handle, \
            const xam_string, \
            xiterator_handle *const);
        typedef xam_status (*XSet_OpenFieldIteratorFunc) \
            (const xset_handle, \
            const xam_string, \
            xiterator_handle *const);    
        typedef xam_status (*XIterator_HasNextFunc) \
            (const xiterator_handle, \
             xam_boolean *const);
        typedef xam_status (*XIterator_NextFunc) \
            (const xiterator_handle, \
            xam_string *const);
        typedef xam_status (*XIterator_CloseFunc) \
            (xiterator_handle);
        typedef xam_status (*XSystem_ContainsFieldFunc) \
            (const xsystem_handle, \
            const xam_string, \
            xam_boolean *const);
        typedef xam_status (*XSet_ContainsFieldFunc) \
            (const xset_handle, \
            const xam_string, \
            xam_boolean *const);
        typedef xam_status (*XSet_SetFieldAsBindingFunc) \
            (const xset_handle, \
            const xam_string);
        typedef xam_status (*XSet_SetFieldAsNonbindingFunc) \
            (const xset_handle, \
            const xam_string);
        typedef xam_status (*XSystem_GetFieldTypeFunc) \
            (const xsystem_handle, \
            const xam_string, \
            xam_string *const);
        typedef xam_status (*XSet_GetFieldTypeFunc) \
            (const xset_handle, \
            const xam_string, \
            xam_string *const);
        typedef xam_status (*XSystem_GetFieldLengthFunc) \
            (const xsystem_handle, \
            const xam_string, \
            xam_int *const);
        typedef xam_status (*XSet_GetFieldLengthFunc) \
            (const xset_handle, \
            const xam_string, \
            xam_int *const);
        typedef xam_status (*XSet_GetFieldBindingFunc) \
            (const xset_handle, \
            const xam_string, \
            xam_boolean *const);
        typedef xam_status (*XSystem_GetFieldReadOnlyFunc) \
            (const xsystem_handle, \
            const xam_string, \
            xam_boolean *const);
        typedef xam_status (*XSet_GetFieldReadOnlyFunc) \
            (const xset_handle, \
            const xam_string, \
            xam_boolean *const);
        typedef xam_status (*XSystem_DeleteFieldFunc) \
            (const xsystem_handle, \
            const xam_string);
        typedef xam_status (*XSet_DeleteFieldFunc) \
            (const xset_handle, \
            const xam_string);
        typedef xam_status (*XSystem_CreateBooleanFunc) \
            (const xsystem_handle, \
             const xam_string, \
             const xam_boolean, \
             const xam_boolean);
        typedef xam_status (*XSystem_CreateIntFunc) \
            (const xsystem_handle, \
            const xam_string, \
            const xam_boolean, \
            const xam_int);
        typedef xam_status (*XSystem_CreateDoubleFunc) \
            (const xsystem_handle, \
            const xam_string, \
            const xam_boolean, \
            const xam_double);
        typedef xam_status (*XSystem_CreateXUIDFunc) \
            (const xsystem_handle, \
            const xam_string, \
            const xam_boolean, \
            const xam_xuid);
        typedef xam_status (*XSystem_CreateStringFunc) \
            (const xsystem_handle, \
            const xam_string, \
            const xam_boolean, \
            const xam_string);
        typedef xam_status (*XSystem_CreateDatetimeFunc) \
            (const xsystem_handle, \
            const xam_string, \
            const xam_boolean, \
            const xam_datetime);
        typedef xam_status (*XSystem_SetBooleanFunc) \
            (const xsystem_handle, \
            const xam_string, \
            const xam_boolean);
        typedef xam_status (*XSystem_SetIntFunc) \
            (const xsystem_handle, \
            const xam_string, \
            const xam_int);
        typedef xam_status (*XSystem_SetDoubleFunc) \
            (const xsystem_handle, \
            const xam_string, \
            const xam_double);
        typedef xam_status (*XSystem_SetXUIDFunc) \
            (const xsystem_handle, \
            const xam_string, \
            const xam_xuid);
        typedef xam_status (*XSystem_SetStringFunc) \
            (const xsystem_handle, \
            const xam_string, \
            const xam_string);
        typedef xam_status (*XSystem_SetDatetimeFunc) \
            (const xsystem_handle, \
            const xam_string, \
            const xam_datetime);
        typedef xam_status (*XSystem_GetBooleanFunc) \
            (const xsystem_handle, \
            const xam_string, \
            xam_boolean *const);
        typedef xam_status (*XSystem_GetIntFunc) \
            (const xsystem_handle, \
            const xam_string, \
            xam_int *const);
        typedef xam_status (*XSystem_GetDoubleFunc) \
            (const xsystem_handle, \
            const xam_string, \
            xam_double *const);
        typedef xam_status (*XSystem_GetXUIDFunc) \
            (const xsystem_handle, \
            const xam_string, \
            xam_xuid *const);
        typedef xam_status (*XSystem_GetStringFunc) \
            (const xsystem_handle, \
            const xam_string, \
            xam_string *const);
        typedef xam_status (*XSystem_GetDatetimeFunc) \
            (const xsystem_handle, \
            const xam_string, \
            xam_datetime *const);
        typedef xam_status (*XSystem_CreateXStreamFunc) \
            (const xsystem_handle, \
            const xam_string, \
            const xam_boolean, \
            const xam_string, \
            xstream_handle *const);
        typedef xam_status (*XSystem_OpenXStreamFunc) \
            (const xsystem_handle, \
            const xam_string, \
            const xam_string, \
            xstream_handle *const);
        typedef xam_status (*XSet_CreateBooleanFunc) \
            (const xset_handle, \
             const xam_string, \
             const xam_boolean, \
             const xam_boolean);
        typedef xam_status (*XSet_CreateIntFunc) \
            (const xset_handle, \
             const xam_string, \
             const xam_boolean, \
             const xam_int);
        typedef xam_status (*XSet_CreateDoubleFunc) \
            (const xset_handle, \
            const xam_string, \
            const xam_boolean, \
            const xam_double);
        typedef xam_status (*XSet_CreateXUIDFunc) \
            (const xset_handle, \
            const xam_string, \
            const xam_boolean, \
            const xam_xuid);
        typedef xam_status (*XSet_CreateStringFunc) \
            (const xset_handle, \
            const xam_string, \
            const xam_boolean, \
            const xam_string);
        typedef xam_status (*XSet_CreateDatetimeFunc) \
            (const xset_handle, \
            const xam_string, \
            const xam_boolean, \
            const xam_datetime);
        typedef xam_status (*XSet_SetBooleanFunc)\
            (const xset_handle, \
            const xam_string, \
            const xam_boolean);
        typedef xam_status (*XSet_SetIntFunc)\
            (const xset_handle, \
            const xam_string, \
            const xam_int);
        typedef xam_status (*XSet_SetDoubleFunc)\
            (const xset_handle, \
            const xam_string, \
            const xam_double);
        typedef xam_status (*XSet_SetXUIDFunc)\
            (const xset_handle, \
            const xam_string, \
            const xam_xuid);
        typedef xam_status (*XSet_SetStringFunc)\
            (const xset_handle, \
            const xam_string, \
            const xam_string);
        typedef xam_status (*XSet_SetDatetimeFunc)\
            (const xset_handle, \
            const xam_string, \
            const xam_datetime);
        typedef xam_status (*XSet_GetBooleanFunc)\
            (const xset_handle, \
             const xam_string, \
             xam_boolean *const);
        typedef xam_status (*XSet_GetIntFunc)\
            (const xset_handle, \
             const xam_string, \
             xam_int *const);
        typedef xam_status (*XSet_GetDoubleFunc)\
            (const xset_handle, \
             const xam_string, \
             xam_double *const);
        typedef xam_status (*XSet_GetXUIDFunc)\
            (const xset_handle, \
             const xam_string, \
             xam_xuid *const);
        typedef xam_status (*XSet_GetStringFunc)\
            (const xset_handle, \
             const xam_string, \
             xam_string *const);
        typedef xam_status (*XSet_GetDatetimeFunc)\
            (const xset_handle, \
             const xam_string, \
             xam_datetime *const);
        typedef xam_status (*XSet_CreateXStreamFunc)\
            (const xset_handle, \
            const xam_string, \
            const xam_boolean, \
            const xam_string, \
            xstream_handle *const);
        typedef xam_status (*XSet_OpenXStreamFunc)\
            (const xset_handle, \
            const xam_string, \
            const xam_string, \
            xstream_handle *const);
        typedef xam_status (*XStream_ReadFunc)\
            (const xstream_handle, \
            char *const, \
            const xam_int, \
            xam_int *const);
        typedef xam_status (*XStream_WriteFunc)\
            (const xstream_handle, \
            const char*, \
            const xam_int, \
            xam_int *const);
        typedef xam_status (*XStream_SeekFunc)\
            (const xstream_handle, \
            const xam_int, \
            const xam_int);
        typedef xam_status (*XStream_TellFunc)\
            (const xstream_handle, \
            xam_int *const);
        typedef xam_status (*XStream_CloseFunc)\
            (xstream_handle);
        typedef xam_status (*XStream_AbandonFunc)\
            (xstream_handle);
        typedef xam_status (*VIM_CreateXSystemFunc)\
            (xsystem_handle *const);
        typedef xam_status (*VIM_XSystem_ConnectFunc)\
            (const xsystem_handle, \
             const xam_string);
        typedef xam_status (*XSystem_AuthenticateFunc)\
            (const xsystem_handle, \
            const char*, \
            const xam_int, \
            xstream_handle *const);
        typedef xam_status (*XSystem_CloseFunc)\
            (const xsystem_handle);
        typedef xam_status (*XSystem_AbandonFunc)\
            (const xsystem_handle); 
        typedef xam_status (*XSystem_DeleteXSetFunc)\
            (const xsystem_handle, \
            const xam_xuid);
        typedef xam_status (*XSystem_HoldXSetFunc)\
            (const xsystem_handle, \
            const xam_xuid, \
            const xam_string);
        typedef xam_status (*XSystem_ReleaseXSetFunc)\
            (const xsystem_handle, \
            const xam_xuid, \
            const xam_string);
        typedef xam_status (*XSystem_AccessXSetFunc)\
            (const xsystem_handle, \
            const xam_xuid, \
            const xam_int, \
            xam_boolean *const); 
        typedef xam_status (*XSystem_IsXSetRetainedFunc)\
            (const xsystem_handle, \
             const xam_xuid, \
             xam_boolean* const);
        typedef xam_status (*XSystem_GetXSetAccessTimeFunc) \
            (const xsystem_handle, \
            const xam_xuid, \
            xam_datetime *const);        
        typedef xam_status (*XSystem_CreateXSetFunc)\
            (const xsystem_handle, \
            const xam_string, \
            xset_handle *const);
        typedef xam_status (*XSet_ApplyAccessPolicyFunc)\
            (const xset_handle, \
            const xam_boolean, \
            const xam_string);
        typedef xam_status (*XSet_ResetAccessFieldsFunc)\
            (const xset_handle);
        typedef xam_status (*XSet_ApplyManagementPolicyFunc)\
            (const xset_handle, \
            const xam_boolean, \
            const xam_string);
        typedef xam_status (*XSet_ResetManagementFieldsFunc)\
            (const xset_handle);
        typedef xam_status (*XSet_CreateRetentionFunc)\
            (const xset_handle, \
             const xam_boolean, \
             const xam_string);
        typedef xam_status (*XSet_SetRetentionEnabledFlagFunc)\
            (const xset_handle, \
             const xam_string,\
             const xam_boolean,\
             const xam_boolean);
        typedef xam_status (*XSet_ApplyRetentionEnabledPolicyFunc)\
            (const xset_handle,\
             const xam_string,\
             const xam_boolean,\
             const xam_string);
        typedef xam_status (*XSet_SetRetentionDurationFunc)\
            (const xset_handle,\
             const xam_string,\
             const xam_boolean,\
             const xam_int);
        typedef xam_status (*XSet_ApplyRetentionDurationPolicyFunc)\
            (const xset_handle,\
             const xam_string,\
             const xam_boolean,\
             const xam_string);
        typedef xam_status (*XSet_SetRetentionStarttimeFunc)\
            (const xset_handle,\
             const xam_string,\
             const xam_boolean);
        typedef xam_status (*XSet_SetBaseRetentionFunc)\
            (const xset_handle,\
             const xam_boolean,\
             const xam_int);
        typedef xam_status (*XSet_ApplyBaseRetentionPolicyFunc)\
            (const xset_handle,\
             const xam_boolean,\
             const xam_string);
        typedef xam_status (*XSet_ApplyAutoDeletePolicyFunc)\
            (const xset_handle,\
             const xam_boolean,\
             const xam_string);
        typedef xam_status (*XSet_SetAutoDeleteFunc) \
            (const xset_handle, \
            const xam_boolean, \
            const xam_boolean);
        typedef xam_status (*XSet_ApplyShredPolicyFunc)\
            (const xset_handle, \
            const xam_boolean, \
            const xam_string);
        typedef xam_status (*XSet_SetShredFunc) \
            (const xset_handle, \
            const xam_boolean, \
            const xam_boolean);
        typedef xam_status (*XSet_ApplyStoragePolicyFunc) \
            (const xset_handle, \
            const xam_boolean, \
            const xam_string);
        typedef xam_status (*XSet_GetActualRetentionDurationFunc)\
            (const xset_handle,\
             const xam_string,\
             xam_int *const);
        typedef xam_status (*XSet_GetActualRetentionEnabledFunc)\
            (const xset_handle,\
             const xam_string,\
             xam_boolean *const);
        typedef xam_status (*XSet_GetActualAutoDeleteFunc)\
            (const xset_handle, \
            xam_boolean *const);
        typedef xam_status (*XSet_GetActualShredFunc)\
            (const xset_handle, \
            xam_boolean *const);
        typedef xam_status (*XSystem_OpenXSetFunc) \
            (const xsystem_handle, \
            const xam_xuid, \
            const xam_string, \
            xset_handle *const);
        typedef xam_status (*XSystem_CopyXSetFunc) \
            (const xsystem_handle, \
             const xam_xuid, \
             const xam_string, \
             xset_handle *const);
        typedef xam_status (*XSet_CommitFunc)\
            (const xset_handle, \
            xam_xuid *const);
        typedef xam_status (*XSet_CloseFunc)\
            (const xset_handle);
        typedef xam_status (*XSet_AbandonFunc)\
            (const xset_handle);
        typedef xam_status (*XSet_OpenExportXStreamFunc)\
            (const xset_handle, \
            xstream_handle *const);
        typedef xam_status (*XSet_OpenImportXStreamFunc) \
            (const xset_handle, \
            xstream_handle *const);
        typedef xam_status (*XSet_SubmitJobFunc)\
            (const xset_handle);
        typedef xam_status (*XSet_HaltJobFunc)\
            (const xset_handle);
        typedef xam_status (*XSystem_AsyncOpenXSetFunc) \
            (const xsystem_handle,
             const xam_xuid,
             const xam_string,
             const XOPID,
             xasync_callback,
             xasync_handle *const); 
        typedef xam_status (*XSystem_AsyncCopyXSetFunc) \
            (const xsystem_handle,
             const xam_xuid,
             const xam_string,
             const XOPID,
             xasync_callback,
             xasync_handle *const); 
        typedef xam_status (*XSystem_AsyncOpenXStreamFunc) \
             (const xsystem_handle,
              const xam_string,
              const xam_string,
              const XOPID,
              xasync_callback,
              xasync_handle *const);
        typedef xam_status (*XSet_AsyncOpenXStreamFunc) \
             (const xset_handle,
              const xam_string,
              const xam_string,
              const XOPID,
              xasync_callback,
              xasync_handle *const);
        typedef xam_status (*XStream_AsyncReadFunc) \
             (const xstream_handle inHandle,
              char* const ioBuffer,
              const xam_int,
              const XOPID,
              xasync_callback,
              xasync_handle *const);
        typedef xam_status (*XStream_AsyncWriteFunc) \
             (const xstream_handle,
              const char*,
              const xam_int,
              const XOPID,
              xasync_callback,
              xasync_handle *const); 
        typedef xam_status (*XSet_AsyncCommitFunc) \
             (const xset_handle,
              const XOPID,
              xasync_callback,
              xasync_handle* const outAsyncHandle); 
        typedef xam_status (*XStream_AsyncCloseFunc) \
             (const xstream_handle,
              const XOPID,
              xasync_callback,
              xasync_handle *const); 
        typedef xam_status (*XAsync_HaltFunc) \
             (const xasync_handle);
        typedef xam_status (*XAsync_IsCompleteFunc) \
             (const xasync_handle,
              xam_boolean *const);
        typedef xam_status (*XAsync_GetStatusFunc) \
             (const xasync_handle,
              xam_status *const);
        typedef xam_status (*XAsync_GetXOPIDFunc) \
             (const xasync_handle,
              XOPID *const);
        typedef xam_status (*XAsync_GetXSetFunc) \
             (const xasync_handle,
              xset_handle *const);
        typedef xam_status (*XAsync_GetXStreamFunc) \
             (const xasync_handle,
              xstream_handle *const);
        typedef xam_status (*XAsync_GetXUIDFunc) \
             (const xasync_handle,
              xam_xuid *const);
        typedef xam_status (*XAsync_GetBytesReadFunc) \
             (const xasync_handle,
              xam_int *const);
        typedef xam_status (*XAsync_GetBytesWrittenFunc) \
             (const xasync_handle,
              xam_int *const);
        typedef xam_status (*XAsync_CloseFunc) \
             (const xasync_handle);
    }
}

/** 
 *  Represents and interfaces with a specific XAM VIM library 
 *  using the VIM API.
 */
class XAM_VIM
{
    private:    
      
        xam_string mLibPath;        // Full path to the VIM library
        xam_string mLibName;        // Name of this VIM library
        void* mVimLibraryHandle;    // Handle to the loaded VIM library 

        /* 
         * Loads the given library into this object  
         *
         * @param inPath  - Path to the VIM library
         * @return - true on success, false on failure
         */
        xam_boolean 
        loadLibrary(const char* inPath);

        /* 
         * Releases an existing library handle
         */
        void 
        closeLibrary();

        /* 
         * Parses the lib name from the given path
         *
         * @param inPath  The full path to the library
         * @param outName The library name is written here
         */
        static void 
        parseLibNameFromPath(xam_string* inPath, xam_string* const outName);

        // =========================================================
        // Function pointers for each VIM API method (set on demand)
        // =========================================================
        XSystem_GetErrorTokenFunc         VIM_XSystem_GetErrorToken;
        XSystem_OpenFieldIteratorFunc   VIM_XSystem_OpenFieldIterator;
        XSet_OpenFieldIteratorFunc      VIM_XSet_OpenFieldIterator;
        XIterator_HasNextFunc             VIM_XIterator_HasNext;
        XIterator_NextFunc                VIM_XIterator_Next;
        XIterator_CloseFunc               VIM_XIterator_Close;
        XSystem_ContainsFieldFunc         VIM_XSystem_ContainsField;
        XSet_ContainsFieldFunc            VIM_XSet_ContainsField;
        XSet_SetFieldAsBindingFunc        VIM_XSet_SetFieldAsBinding;    
        XSet_SetFieldAsNonbindingFunc     VIM_XSet_SetFieldAsNonbinding;    
        XSystem_GetFieldTypeFunc          VIM_XSystem_GetFieldType;   
        XSystem_GetFieldLengthFunc        VIM_XSystem_GetFieldLength;   
        XSystem_GetFieldReadOnlyFunc      VIM_XSystem_GetFieldReadOnly;   
        XSystem_DeleteFieldFunc           VIM_XSystem_DeleteField;  
        XSystem_CreateBooleanFunc         VIM_XSystem_CreateBoolean;   
        XSystem_CreateIntFunc             VIM_XSystem_CreateInt;       
        XSystem_CreateDoubleFunc           VIM_XSystem_CreateDouble;    
        XSystem_CreateXUIDFunc            VIM_XSystem_CreateXUID;    
        XSystem_CreateStringFunc          VIM_XSystem_CreateString;    
        XSystem_CreateDatetimeFunc        VIM_XSystem_CreateDatetime;   
        XSystem_SetBooleanFunc            VIM_XSystem_SetBoolean;    
        XSystem_SetIntFunc                VIM_XSystem_SetInt;     
        XSystem_SetDoubleFunc              VIM_XSystem_SetDouble;    
        XSystem_SetXUIDFunc               VIM_XSystem_SetXUID;   
        XSystem_SetStringFunc             VIM_XSystem_SetString;    
        XSystem_SetDatetimeFunc           VIM_XSystem_SetDatetime;    
        XSystem_GetBooleanFunc            VIM_XSystem_GetBoolean;    
        XSystem_GetIntFunc                VIM_XSystem_GetInt;      
        XSystem_GetDoubleFunc              VIM_XSystem_GetDouble;
        XSystem_GetXUIDFunc               VIM_XSystem_GetXUID; 
        XSystem_GetStringFunc             VIM_XSystem_GetString;  
        XSystem_GetDatetimeFunc           VIM_XSystem_GetDatetime;   
        XSystem_CreateXStreamFunc         VIM_XSystem_CreateXStream;  
        XSystem_OpenXStreamFunc           VIM_XSystem_OpenXStream;  
        XSet_GetFieldTypeFunc             VIM_XSet_GetFieldType;   
        XSet_GetFieldLengthFunc           VIM_XSet_GetFieldLength;   
        XSet_GetFieldBindingFunc          VIM_XSet_GetFieldBinding;  
        XSet_GetFieldReadOnlyFunc         VIM_XSet_GetFieldReadOnly;   
        XSet_DeleteFieldFunc              VIM_XSet_DeleteField;  
        XSet_CreateBooleanFunc            VIM_XSet_CreateBoolean;   
        XSet_CreateIntFunc                VIM_XSet_CreateInt;       
        XSet_CreateDoubleFunc              VIM_XSet_CreateDouble;    
        XSet_CreateXUIDFunc               VIM_XSet_CreateXUID;    
        XSet_CreateStringFunc             VIM_XSet_CreateString;    
        XSet_CreateDatetimeFunc           VIM_XSet_CreateDatetime;   
        XSet_SetBooleanFunc               VIM_XSet_SetBoolean;    
        XSet_SetIntFunc                   VIM_XSet_SetInt;     
        XSet_SetDoubleFunc                 VIM_XSet_SetDouble;    
        XSet_SetXUIDFunc                  VIM_XSet_SetXUID;   
        XSet_SetStringFunc                VIM_XSet_SetString;    
        XSet_SetDatetimeFunc              VIM_XSet_SetDatetime;    
        XSet_GetBooleanFunc               VIM_XSet_GetBoolean;    
        XSet_GetIntFunc                   VIM_XSet_GetInt;      
        XSet_GetDoubleFunc                 VIM_XSet_GetDouble;
        XSet_GetXUIDFunc                  VIM_XSet_GetXUID; 
        XSet_GetStringFunc                VIM_XSet_GetString;  
        XSet_GetDatetimeFunc              VIM_XSet_GetDatetime;   
        XSet_CreateXStreamFunc            VIM_XSet_CreateXStream;  
        XSet_OpenXStreamFunc              VIM_XSet_OpenXStream;  
        XStream_ReadFunc                  VIM_XStream_Read;   
        XStream_WriteFunc                 VIM_XStream_Write;  
        XStream_SeekFunc                  VIM_XStream_Seek;   
        XStream_TellFunc                  VIM_XStream_Tell;   
        XStream_CloseFunc                 VIM_XStream_Close;
        XStream_AbandonFunc               VIM_XStream_Abandon;
        VIM_CreateXSystemFunc             VIM_CreateXSystem;
        VIM_XSystem_ConnectFunc           VIM_XSystem_Connect;
        XSystem_AuthenticateFunc          VIM_XSystem_Authenticate;   
        XSystem_CloseFunc                 VIM_XSystem_Close;    
        XSystem_AbandonFunc               VIM_XSystem_Abandon;     
        XSystem_DeleteXSetFunc            VIM_XSystem_DeleteXSet;   
        XSystem_HoldXSetFunc              VIM_XSystem_HoldXSet;    
        XSystem_ReleaseXSetFunc           VIM_XSystem_ReleaseXSet;   
        XSystem_AccessXSetFunc            VIM_XSystem_AccessXSet;  
        XSystem_IsXSetRetainedFunc        VIM_XSystem_IsXSetRetained;
        XSystem_GetXSetAccessTimeFunc     VIM_XSystem_GetXSetAccessTime;    
        XSystem_CreateXSetFunc            VIM_XSystem_CreateXSet;    
        XSet_ApplyAccessPolicyFunc        VIM_XSet_ApplyAccessPolicy;
        XSet_ResetAccessFieldsFunc        VIM_XSet_ResetAccessFields;
        XSet_ApplyManagementPolicyFunc    VIM_XSet_ApplyManagementPolicy;  
        XSet_ResetManagementFieldsFunc    VIM_XSet_ResetManagementFields;
        XSet_CreateRetentionFunc          VIM_XSet_CreateRetention;
        XSet_SetRetentionEnabledFlagFunc        VIM_XSet_SetRetentionEnabledFlag;
        XSet_ApplyRetentionEnabledPolicyFunc    VIM_XSet_ApplyRetentionEnabledPolicy;
        XSet_SetRetentionDurationFunc           VIM_XSet_SetRetentionDuration;
        XSet_ApplyRetentionDurationPolicyFunc   VIM_XSet_ApplyRetentionDurationPolicy;
        XSet_SetRetentionStarttimeFunc          VIM_XSet_SetRetentionStarttime;
        XSet_SetBaseRetentionFunc               VIM_XSet_SetBaseRetention;
        XSet_ApplyBaseRetentionPolicyFunc       VIM_XSet_ApplyBaseRetentionPolicy;
        XSet_ApplyAutoDeletePolicyFunc          VIM_XSet_ApplyAutoDeletePolicy;  
        XSet_SetAutoDeleteFunc                  VIM_XSet_SetAutoDelete; 
        XSet_ApplyShredPolicyFunc               VIM_XSet_ApplyShredPolicy;  
        XSet_SetShredFunc                       VIM_XSet_SetShred;   
        XSet_ApplyStoragePolicyFunc             VIM_XSet_ApplyStoragePolicy;   
        XSet_GetActualRetentionDurationFunc     VIM_XSet_GetActualRetentionDuration;
        XSet_GetActualRetentionEnabledFunc      VIM_XSet_GetActualRetentionEnabled;
        XSet_GetActualAutoDeleteFunc     VIM_XSet_GetActualAutoDelete;  
        XSet_GetActualAutoDeleteFunc     VIM_XSet_GetActualShred;  
        XSystem_OpenXSetFunc             VIM_XSystem_OpenXSet;  
        XSystem_CopyXSetFunc             VIM_XSystem_CopyXSet;  
        XSet_CommitFunc                  VIM_XSet_Commit;    
        XSet_CloseFunc                   VIM_XSet_Close;    
        XSet_AbandonFunc                 VIM_XSet_Abandon;   
        XSet_OpenExportXStreamFunc       VIM_XSet_OpenExportXStream;    
        XSet_OpenImportXStreamFunc       VIM_XSet_OpenImportXStream;   
        XSet_SubmitJobFunc               VIM_XSet_SubmitJob;    
        XSet_HaltJobFunc                 VIM_XSet_HaltJob;   
        XSystem_AsyncOpenXSetFunc        VIM_XSystem_AsyncOpenXSet;
        XSystem_AsyncCopyXSetFunc        VIM_XSystem_AsyncCopyXSet;
        XSystem_AsyncOpenXStreamFunc     VIM_XSystem_AsyncOpenXStream;
        XSet_AsyncOpenXStreamFunc        VIM_XSet_AsyncOpenXStream;
        XStream_AsyncReadFunc            VIM_XStream_AsyncRead;
        XStream_AsyncWriteFunc           VIM_XStream_AsyncWrite;
        XSet_AsyncCommitFunc             VIM_XSet_AsyncCommit;
        XStream_AsyncCloseFunc           VIM_XStream_AsyncClose;
        XAsync_HaltFunc                  VIM_XAsync_Halt;
        XAsync_IsCompleteFunc            VIM_XAsync_IsComplete;
        XAsync_GetStatusFunc             VIM_XAsync_GetStatus;
        XAsync_GetXOPIDFunc              VIM_XAsync_GetXOPID;
        XAsync_GetXSetFunc               VIM_XAsync_GetXSet;
        XAsync_GetXStreamFunc            VIM_XAsync_GetXStream;
        XAsync_GetXUIDFunc               VIM_XAsync_GetXUID;
        XAsync_GetBytesReadFunc          VIM_XAsync_GetBytesRead;
        XAsync_GetBytesWrittenFunc       VIM_XAsync_GetBytesWritten;
        XAsync_CloseFunc                 VIM_XAsync_Close;

    public: 

        /** 
         * Constructor  Loads the given library
         * 
         * @param inLibName  Name of an existing VIM library 
         *                   (may contain full path)
         * @throws  XAMVimNotFoundException on error     
         */
        XAM_VIM(const char* inLibName);

        /** Destructor  Unloads library resources */
        ~XAM_VIM(); 

        /* 
         * Get the full path to this VIM library (if known)
         *
         * @return  The full path to this VIM library 
         *          (or VIM name if not specified)
         */
        const char* 
        getPath() { return &mLibPath[0]; }

        /* 
         * Get the name of this VIM object
         *
         * @return   The name of this VIM object
         */
        const char* 
        getName();

        // ====================================================================
        // methods to handle void 
        // ====================================================================

        /** @see vim.h for detailed description */
        xam_boolean
        XSystem_GetErrorToken (const xsystem_handle inHandle,
                               const xam_status inStatus,
                               xam_string* const outToken);

        // ====================================================================
        // method prototypes for the XIterator 
        // ====================================================================

        /** @see vim.h for detailed description */
        void
        XSystem_OpenFieldIterator (const xsystem_handle inHandle,  
                                   const xam_string inPattern,
                                   xiterator_handle* const outIterator);

        /** @see vim.h for detailed description */
        void
        XSet_OpenFieldIterator (const xset_handle inHandle,  
                                  const xam_string inPattern,
                                  xiterator_handle* const outIterator);

        /** @see vim.h for detailed description */
        void
        XIterator_HasNext (const xiterator_handle inHandle, 
                           xam_boolean* const outValue);

        /** @see vim.h for detailed description */
        void 
        XIterator_Next (const xiterator_handle inHandle, 
                        xam_string* const outName);
      
        /** @see vim.h for detailed description */
        void 
        XIterator_Close (xiterator_handle inHandle);


        // ====================================================================
        // method prototypes for managing XSystem Fields 
        // ====================================================================

        /** @see vim.h for detailed description */
        void 
        XSystem_ContainsField (const xsystem_handle inHandle,
                               const xam_string inName,
                               xam_boolean* const outExists);

        /** @see vim.h for detailed description */
        void 
        XSystem_GetFieldType (const xsystem_handle inHandle,
                              const xam_string inName,
                              xam_string* const outType);

        /** @see vim.h for detailed description */
        void 
        XSystem_GetFieldLength (const xsystem_handle inHandle,
                                const xam_string inName,
                                xam_int* const outLength);
        /** @see vim.h for detailed description */
        void 
        XSystem_GetFieldReadOnly (const xsystem_handle inHandle,
                                  const xam_string inName,
                                  xam_boolean* const outReadOnly);

        /** @see vim.h for detailed description */
        void 
        XSystem_DeleteField (const xsystem_handle inHandle,
                             const xam_string inName);

        // ====================================================================
        // method prototypes for managing XSet Fields (properties or XStreams)
        // ====================================================================

        /** @see vim.h for detailed description */
        void 
        XSet_ContainsField (const xset_handle inHandle,
                            const xam_string inName,
                            xam_boolean* const outExists);

        /** @see vim.h for detailed description */
        void 
        XSet_SetFieldAsBinding (const xset_handle inHandle,
                                const xam_string inName);

        /** @see vim.h for detailed description */
        void 
        XSet_SetFieldAsNonbinding (const xset_handle inHandle,
                                   const xam_string inName);

        /** @see vim.h for detailed description */
        void 
        XSet_GetFieldType (const xset_handle inHandle,
                           const xam_string inName,
                           xam_string* const outType);

        /** @see vim.h for detailed description */
        void 
        XSet_GetFieldLength (const xset_handle inHandle,
                             const xam_string inName,
                             xam_int* const outLength);

        /** @see vim.h for detailed description */
        void 
        XSet_GetFieldBinding (const xset_handle inHandle,
                              const xam_string inName,
                              xam_boolean* const outFixed);
        /** @see vim.h for detailed description */
        void 
        XSet_GetFieldReadOnly (const xset_handle inHandle,
                               const xam_string inName,
                               xam_boolean* const outReadOnly);

        /** @see vim.h for detailed description */
        void 
        XSet_DeleteField (const xset_handle inHandle,
                          const xam_string inName);

        // ====================================================================
        // method prototypes for managing XSystem property fields
        // ====================================================================

        /** @see vim.h for detailed description */
        void 
        XSystem_CreateBoolean (const xsystem_handle inHandle,
                               const xam_string inName,
                               const xam_boolean inBinding,
                               const xam_boolean inValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_CreateInt (const xsystem_handle inHandle,
                           const xam_string inName,
                           const xam_boolean inBinding,
                           const xam_int inValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_CreateDouble (const xsystem_handle inHandle,
                             const xam_string inName,
                             const xam_boolean inBinding,
                             const xam_double inValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_CreateXUID (const xsystem_handle inHandle,
                            const xam_string inName,
                            const xam_boolean inBinding,
                            const xam_xuid inValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_CreateString (const xsystem_handle inHandle,
                              const xam_string inName,
                              const xam_boolean inBinding,
                              const xam_string inValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_CreateDatetime (const xsystem_handle inHandle,
                                const xam_string inName,
                                const xam_boolean inBinding,
                                const xam_datetime inValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_SetBoolean (const xsystem_handle inHandle,
                            const xam_string inName,
                            const xam_boolean inValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_SetInt (const xsystem_handle inHandle,
                        const xam_string inName,
                        const xam_int inValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_SetDouble (const xsystem_handle inHandle,
                          const xam_string inName,
                          const xam_double inValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_SetXUID (const xsystem_handle inHandle,
                         const xam_string inName,
                         const xam_xuid inValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_SetString (const xsystem_handle inHandle,
                           const xam_string inName,
                           const xam_string inValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_SetDatetime (const xsystem_handle inHandle,
                             const xam_string inName,
                             const xam_datetime inValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_GetBoolean (const xsystem_handle inHandle,
                            const xam_string inName,
                            xam_boolean* const outValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_GetInt (const xsystem_handle inHandle,
                        const xam_string inName,
                        xam_int* const outValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_GetDouble (const xsystem_handle inHandle,
                          const xam_string inName,
                          xam_double* const outValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_GetXUID (const xsystem_handle inHandle,
                         const xam_string inName,
                         xam_xuid* const outValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_GetString (const xsystem_handle inHandle,
                           const xam_string inName,
                           xam_string* const outValue);

        /** @see vim.h for detailed description */
        void 
        XSystem_GetDatetime (const xsystem_handle inHandle,
                             const xam_string inName,
                             xam_datetime* const outValue);

        // ====================================================================
        // method prototypes for managing XSet property fields
        // ====================================================================

        /** @see vim.h for detailed description */
        void 
        XSet_CreateBoolean (const xset_handle inHandle,
                            const xam_string inName,
                            const xam_boolean inBinding,
                            const xam_boolean inValue);

        /** @see vim.h for detailed description */
        void 
        XSet_CreateInt (const xset_handle inHandle,
                        const xam_string inName,
                        const xam_boolean inBinding,
                        const xam_int inValue);

        /** @see vim.h for detailed description */
        void 
        XSet_CreateDouble (const xset_handle inHandle,
                         const xam_string inName,
                         const xam_boolean inBinding,
                         const xam_double inValue);

        /** @see vim.h for detailed description */
        void 
        XSet_CreateXUID (const xset_handle inHandle,
                         const xam_string inName,
                         const xam_boolean inBinding,
                         const xam_xuid inValue);

        /** @see vim.h for detailed description */
        void 
        XSet_CreateString (const xset_handle inHandle,
                          const xam_string inName,
                          const xam_boolean inBinding,
                          const xam_string inValue);

        /** @see vim.h for detailed description */
        void 
        XSet_CreateDatetime (const xset_handle inHandle,
                             const xam_string inName,
                             const xam_boolean inBinding,
                             const xam_datetime inValue);

        /** @see vim.h for detailed description */
        void 
        XSet_SetBoolean (const xset_handle inHandle,
                         const xam_string inName,
                         const xam_boolean inValue);

        /** @see vim.h for detailed description */
        void 
        XSet_SetInt (const xset_handle inHandle,
                     const xam_string inName,
                     const xam_int inValue);

        /** @see vim.h for detailed description */
        void 
        XSet_SetDouble (const xset_handle inHandle,
                        const xam_string inName,
                        const xam_double inValue);

        /** @see vim.h for detailed description */
        void 
        XSet_SetXUID (const xset_handle inHandle,
                      const xam_string inName,
                      const xam_xuid inValue);

        /** @see vim.h for detailed description */
        void 
        XSet_SetString (const xset_handle inHandle,
                        const xam_string inName,
                        const xam_string inValue);

        /** @see vim.h for detailed description */
        void 
        XSet_SetDatetime (const xset_handle inHandle,
                          const xam_string inName,
                          const xam_datetime inValue);

        /** @see vim.h for detailed description */
        void 
        XSet_GetBoolean (const xset_handle inHandle,
                         const xam_string inName,
                         xam_boolean* const outValue);

        /** @see vim.h for detailed description */
        void 
        XSet_GetInt (const xset_handle inHandle,
                     const xam_string inName,
                     xam_int* const outValue);

        /** @see vim.h for detailed description */
        void 
        XSet_GetDouble (const xset_handle inHandle,
                       const xam_string inName,
                       xam_double* const outValue);

        /** @see vim.h for detailed description */
        void 
        XSet_GetXUID (const xset_handle inHandle,
                      const xam_string inName,
                      xam_xuid* const outValue);

        /** @see vim.h for detailed description */
        void 
        XSet_GetString (const xset_handle inHandle,
                        const xam_string inName,
                        xam_string* const outValue);

        /** @see vim.h for detailed description */
        void 
        XSet_GetDatetime (const xset_handle inHandle,
                          const xam_string inName,
                          xam_datetime* const outValue);


        // ====================================================================
        // method prototypes for XStreams and XStream fields
        // ====================================================================

        /** @see vim.h for detailed description */
        void 
        XSystem_CreateXStream (const xsystem_handle inHandle,
                               const xam_string inName,
                               const xam_boolean inBinding,
                               const xam_string inType,
                               xstream_handle* const outXStream);

        /** @see vim.h for detailed description */
        void
        XSystem_OpenXStream (const xsystem_handle inHandle,
                             const xam_string inName,
                             const xam_string inMode,
                             xstream_handle* const outXStream);   

        /** @see vim.h for detailed description */
        void 
        XSet_CreateXStream (const xset_handle inHandle,
                            const xam_string inName,
                            const xam_boolean inBinding,
                            const xam_string inType,
                            xstream_handle* const outXStream);

        /** @see vim.h for detailed description */
        void
        XSet_OpenXStream (const xset_handle inHandle,
                          const xam_string inName,
                          const xam_string inMode,
                          xstream_handle* const outXStream);   

        /** @see vim.h for detailed description */
        void 
        XStream_Read (const xstream_handle inHandle,
                      char* const ioBuffer,
                      const xam_int inBufferLength,
                      xam_int* const outBytesRead);

        /** @see vim.h for detailed description */
        void 
        XStream_Write (const xstream_handle inHandle,
                       const char* inBuffer,
                       const xam_int inByteCount,
                       xam_int* const outByteWritten);

        /** @see vim.h for detailed description */
        void 
        XStream_Seek (const xstream_handle inHandle,
                      const xam_int inOffset,
                      const xam_int inWhence);

        /** @see vim.h for detailed description */
        void 
        XStream_Tell (const xstream_handle inHandle,
                      xam_int* const outPosition);

        /** @see vim.h for detailed description */
        void
        XStream_Abandon (xstream_handle inHandle);

        /** @see vim.h for detailed description */
        void 
        XStream_Close (xstream_handle inHandle);

        // ====================================================================
        // prototypes for managing the connection to a XAM storage system
        // ====================================================================

        /** @see vim.h for detailed description */
        void
        CreateXSystem (xsystem_handle* const outHandle);    

        /** @see vim.h for detailed description */
        void 
        XSystem_Connect (const xsystem_handle inHandle,
                         const xam_string inXRI);

        /** @see vim.h for detailed description */
        void 
        XSystem_Authenticate (const xsystem_handle inHandle,
                              const char* inBuffer,
                              const xam_int inByteCount,
                              xstream_handle* const outXStream);

        /** @see vim.h for detailed description */
        void 
        XSystem_Close (const xsystem_handle inHandle);

        /** @see vim.h for detailed description */
        void 
        XSystem_Abandon (const xsystem_handle inHandle);

        // ====================================================================
        // method prototypes for XSet management
        // ====================================================================

        /** @see vim.h for detailed description */
        void 
        XSystem_DeleteXSet (const xsystem_handle inHandle,
                            const xam_xuid inXUID);

        /** @see vim.h for detailed description */
        void 
        XSystem_HoldXSet (const xsystem_handle inHandle,
                          const xam_xuid inXUID,
                          const xam_string inHoldID);

        /** @see vim.h for detailed description */
        void 
        XSystem_ReleaseXSet (const xsystem_handle inHandle,
                             const xam_xuid inXUID,
                             const xam_string inHoldID);

        /** @see vim.h for detailed description */
        void 
        XSystem_AccessXSet (const xsystem_handle inHandle,
                            const xam_xuid inXUID,
                            const xam_int inMode,
                            xam_boolean* const outIsAccessible);

        /** @see vim.h for detailed description */
        void 
        XSystem_IsXSetRetained (const xsystem_handle inHandle,
                                const xam_xuid inXUID,
                                xam_boolean* const outIsRetained);

        /** @see vim.h for detailed description */
        void
        XSystem_GetXSetAccessTime (const xsystem_handle inHandle,
                                   const xam_xuid inXUID,
                                   xam_datetime* const outAccessTime);

        // ====================================================================
        // method prototypes for creating an XSet
        // ====================================================================

        /** @see vim.h for detailed description */
        void 
        XSystem_CreateXSet (const xsystem_handle inHandle,
                            const xam_string inMode,
                            xset_handle* const outXSet);

        // ====================================================================
        // method prototypes for XSet policy management
        // ====================================================================

        /** @see vim.h for detailed description */
        void
        XSet_ApplyAccessPolicy (const xset_handle inHandle,
                                const xam_boolean inBinding,
                                const xam_string inPolicy);

        /** @see vim.h for detailed description */
        void
        XSet_ResetAccessFields (const xset_handle inHandle);

        /** @see vim.h for detailed description */
        void 
        XSet_ApplyManagementPolicy (const xset_handle inHandle,
                                    const xam_boolean inBinding,
                                    const xam_string inPolicy);

        /** @see vim.h for detailed description */
        void
        XSet_ResetManagementFields (const xset_handle inHandle);

        /** @see vim.h for detailed description */
        void
        XSet_CreateRetention (const xset_handle inHandle,
                              const xam_boolean inBinding,
                              const xam_string inRetentionID);

        /** @see vim.h for detailed description */
        void
        XSet_SetRetentionEnabledFlag (const xset_handle inHandle,
                                      const xam_string inRetentionID,
                                      const xam_boolean inBinding,
                                      const xam_boolean inEnabled);

        /** @see vim.h for detailed description */
        void
        XSet_ApplyRetentionEnabledPolicy (const xset_handle inHandle,
                                          const xam_string inRetentionID,
                                          const xam_boolean inBinding,
                                          const xam_string inPolicy);

        /** @see vim.h for detailed description */
        void
        XSet_SetRetentionDuration (const xset_handle inHandle,
                                   const xam_string inRetentionID,
                                   const xam_boolean inBinding,
                                   const xam_int inDuration);

        /** @see vim.h for detailed description */
        void
        XSet_ApplyRetentionDurationPolicy (const xset_handle inHandle,
                                           const xam_string inRetentionID,
                                           const xam_boolean inBinding,
                                           const xam_string inPolicy);

        /** @see vim.h for detailed description */
        void
        XSet_SetRetentionStarttime (const xset_handle inHandle,
                                    const xam_string inRetentionID,
                                    const xam_boolean inBinding);

        /** @see vim.h for detailed description */
        void
        XSet_SetBaseRetention (const xset_handle inHandle,
                               const xam_boolean inBinding,
                               const xam_int inDuration);

        /** @see vim.h for detailed description */
        void
        XSet_ApplyBaseRetentionPolicy (const xset_handle inHandle,
                                       const xam_boolean inBinding,
                                       const xam_string inPolicy);

        /** @see vim.h for detailed description */
        void 
        XSet_ApplyAutoDeletePolicy (const xset_handle inHandle,
                                    const xam_boolean inBinding,
                                    const xam_string inPolicy);

        /** @see vim.h for detailed description */
        void 
        XSet_SetAutoDelete (const xset_handle inHandle,
                            const xam_boolean inBinding,
                            const xam_boolean inAutoDelete);

        /** @see vim.h for detailed description */
        void
        XSet_ApplyShredPolicy (const xset_handle inHandle,
                               const xam_boolean inBinding,
                               const xam_string inPolicy);

        /** @see vim.h for detailed description */
        void
        XSet_SetShred (const xset_handle inHandle,
                       const xam_boolean inBinding,
                       const xam_boolean inShred);

        /** @see vim.h for detailed description */
        void 
        XSet_ApplyStoragePolicy (const xset_handle inHandle,
                                 const xam_boolean inBinding,
                                 const xam_string inPolicy);

        /** @see vim.h for detailed description */
        void 
        XSet_GetActualRetentionDuration (const xset_handle inHandle,
                                         const xam_string inRetentionID,
                                         xam_int* const outDuration);

        /** @see vim.h for detailed description */
        void 
        XSet_GetActualRetentionEnabled (const xset_handle inHandle,
                                        const xam_string inRetentionID,
                                        xam_boolean* const outEnabled);

        /** @see vim.h for detailed description */
        void 
        XSet_GetActualAutoDelete (const xset_handle inHandle,
                                  xam_boolean* const outEnabled);

        /** @see vim.h for detailed description */
        void 
        XSet_GetActualShred (const xset_handle inHandle,
                             xam_boolean* const outEnabled);

        // ====================================================================
        // method prototypes for editing an XSet
        // ====================================================================

        /** @see vim.h for detailed description */
        void 
        XSystem_OpenXSet (const xsystem_handle inHandle,
                          const xam_xuid inXUID,
                          const xam_string inMode,
                          xset_handle* const outXSet);

        /** @see vim.h for detailed description */
        void 
        XSystem_CopyXSet (const xsystem_handle inHandle,
                          const xam_xuid inXUID,
                          const xam_string inMode,
                          xset_handle* const outXSet);

        /** @see vim.h for detailed description */
        void 
        XSet_Commit (const xset_handle inHandle,
                     xam_xuid* const outXUID);

        /** @see vim.h for detailed description */
        void 
        XSet_Close (const xset_handle inHandle);

        /** @see vim.h for detailed description */
        void 
        XSet_Abandon (const xset_handle inHandle);

        // ====================================================================
        // method prototypes for XSet migration
        // ====================================================================

        /** @see vim.h for detailed description */
        void 
        XSet_OpenExportXStream (const xset_handle inHandle,
                                xstream_handle* const outXStream);

        /** @see vim.h for detailed description */
        void 
        XSet_OpenImportXStream (const xset_handle inHandle,
                                xstream_handle* const outXStream);

        // ====================================================================
        // method prototypes for job control
        // ====================================================================

        /** @see vim.h for detailed description */
        void 
        XSet_SubmitJob (const xset_handle inHandle);

        /** @see vim.h for detailed description */
        void 
        XSet_HaltJob (const xset_handle inHandle);

        // ====================================================================
        // method prototypes asynchronous i/o
        // ====================================================================

        /** @see vim.h for detailed description */
        void 
        XSystem_AsyncOpenXSet (const xsystem_handle inHandle,
                               const xam_xuid inXUID,
                               const xam_string inMode,
                               const XOPID inXOPID,
                               xasync_callback inCallback,
                               xasync_handle* const outAsyncHandle); 

        /** @see vim.h for detailed description */
        void 
        XSystem_AsyncCopyXSet (const xsystem_handle inHandle,
                               const xam_xuid inXUID,
                               const xam_string inMode,
                               const XOPID inXOPID,
                               xasync_callback inCallback,
                               xasync_handle* const outAsyncHandle); 

        /** @see vim.h for detailed description */
        void 
        XSystem_AsyncOpenXStream (const xsystem_handle inHandle,
                                  const xam_string inName,
                                  const xam_string inMode,
                                  const XOPID inXOPID,
                                  xasync_callback inCallback,
                                  xasync_handle* const outAsyncHandle);

        /** @see vim.h for detailed description */
        void 
        XSet_AsyncOpenXStream (const xset_handle inHandle,
                               const xam_string inName,
                               const xam_string inMode,
                               const XOPID inXOPID,
                               xasync_callback inCallback,
                               xasync_handle* const outAsyncHandle);
   
        /** @see vim.h for detailed description */
        void 
        XStream_AsyncRead (const xstream_handle inHandle,
                           char* const ioBuffer,
                           const xam_int inBufferLength,
                           const XOPID inXOPID,
                           xasync_callback inCallback,
                           xasync_handle* const outAsyncHandle);

        /** @see vim.h for detailed description */
        void 
        XStream_AsyncWrite (const xstream_handle inHandle,
                            const char* inBuffer,
                            const xam_int inByteCount,
                            const XOPID inXOPID,
                            xasync_callback inCallback,
                            xasync_handle* const outAsyncHandle); 

        /** @see vim.h for detailed description */
        void 
        XSet_AsyncCommit (const xset_handle inHandle,
                          const XOPID inXOPID,
                          xasync_callback inCallback,
                          xasync_handle* const outAsyncHandle); 

        /** @see vim.h for detailed description */
        void 
        XStream_AsyncClose (const xstream_handle inHandle,
                            const XOPID inXOPID,
                            xasync_callback inCallback,
                            xasync_handle* const outAsyncHandle); 

        // ====================================================================
        // method prototypes for managing asyncronous operations
        // ====================================================================

        /** @see vim.h for detailed description */
        void 
        XAsync_Halt (const xasync_handle inHandle);

        /** @see vim.h for detailed description */
        void 
        XAsync_IsComplete (const xasync_handle inHandle,
                           xam_boolean* const outIsComplete);

        /** @see vim.h for detailed description */
        void 
        XAsync_GetStatus (const xasync_handle inHandle,
                          xam_status* const outStatus);

        /** @see vim.h for detailed description */
        void 
        XAsync_GetXOPID (const xasync_handle inHandle,
                         XOPID* const outXOPID);

        /** @see vim.h for detailed description */
        void 
        XAsync_GetXSet (const xasync_handle inHandle,
                        xset_handle* const outXSet);

        /** @see vim.h for detailed description */
        void 
        XAsync_GetXStream (const xasync_handle inHandle,
                           xstream_handle* const outXStream);

        /** @see vim.h for detailed description */
        void 
        XAsync_GetXUID (const xasync_handle inHandle,
                        xam_xuid* const outXUID);

        /** @see vim.h for detailed description */
        void 
        XAsync_GetBytesRead (const xasync_handle inHandle,
                             xam_int* const outBytesRead);

        /** @see vim.h for detailed description */
        void 
        XAsync_GetBytesWritten (const xasync_handle inHandle,
                                xam_int* const outBytesWritten);

        /** @see vim.h for detailed description */
        void 
        XAsync_Close (const xasync_handle inHandle);

};



#endif // __XAM_VIM__


