/******************************************************************************
 *
 * Copyright  2007, The Storage Networking Industry Association
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *    - Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *    - Neither the name of The Storage Networking Industry Association (SNIA)
 *      nor the names of its contributors may be used to endorse or promote
 *      products derived from this software without specific prior written
 *      permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ============================================================================
 *  Copyright  2007, EMC Corporation.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *    - Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *    - The name of EMC Corporation may not be used to endorse or promote
 *      products derived from this software without specific prior written
 *      permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*****************************************************************************
 * XAMErrors Version @version.full@
 *****************************************************************************/

package org.snia.xam;

import org.snia.xam.natives.*;

public class XAMErrors {
    static final int    sXAMException                     = 1001;
    static final int    sXAM_OUT_OF_MEMORY                = 1002;
    static final int    sInvalidArgumentException         = 1003;
    static final int    sXAM_PARAM_NOT_UTF8               = 1004;
    static final int    sXAM_INVALID_HANDLE               = 1005;
    static final int    sInvalidFieldTypeException        = 1006;
    static final int    sInvalidXStreamModeException      = 1007;
    static final int    sInvalidXRIException              = 1008;
    static final int    sInvalidXSetModeException         = 1009;
    static final int    sInvalidFieldNameException        = 1010;
    static final int    sVIMLoadException                 = 1011;
    static final int    sXAM_VIM_SYMBOL_NOT_FOUND         = 1012;
    static final int    sFieldDoesNotExistException       = 1013;
    static final int    sFieldReadOnlyException           = 1014;
    static final int    sFieldExistsException             = 1015;
    static final int    sFieldInUseException             = 1016;
    static final int    sMaximumFieldException            = 1017;
    static final int    sXAM_FILESYSTEM_ERROR             = 1018;
    static final int    sXSystemAbandonException          = 1019;
    static final int    sXSetAbandonException             = 1020;
    static final int    sXStreamAbandonException          = 1021;
    static final int    sXSystemCorruptException          = 1022;
    static final int    sXSetCorruptException             = 1023;
    static final int    sXStreamCorruptException          = 1024;
    static final int    sConnectException                 = 1025;
    static final int    sAuthorizationException           = 1026;
    static final int    sXAM_AUTH_DATA_NEEDED             = 1027;
    static final int    sAuthenticationException          = 1028;
    static final int    sInvalidXUIDException             = 1029;
    static final int    sXSetDoesNotExistException        = 1030;
    static final int    sAsyncPendingException            = 1031;
    static final int    sXAM_NOT_SUPPORTED                = 1032;
    static final int    sInvalidOperationException        = 1033;
    static final int    sObjectInUseException             = 1034;
    static final int    sXAM_NOT_A_JOB                    = 1035;
    static final int    sJobCommandException              = 1036;
    static final int    sXAM_JOB_INVALID_CMD_SYNTAX       = 1037;
    static final int    sJobUnsupportedException          = 1038;
    static final int    sJobPermissionsException          = 1039;
    static final int    sJobResourcesException            = 1040;
    static final int    sJobRunningException              = 1041;
    static final int    sXSetUnderRetentionException      = 1042;
    static final int    sXSetUnderHoldException           = 1043;
    static final int    sHoldIdException                  = 1044;
    static final int    sRetentionValueException          = 1045;
    static final int    sPolicyNameException              = 1046;
    static final int    sXAM_XASYNC_HALTED                = 1047;
    static final int    sPolicyMismatchException          = 1048;

    static final String sInvalidXRIExceptionMessage       = "xam/invalid XRI.";
    static final String sInvalidArgumentExceptionMessage  = "xam/invalid argument.";
    static final String sInvalidFieldTypeExceptionMessage = "xam/invalid field type.";
    static final String sInvalidFieldNameExceptionMessage = "xam/invalid field name.";
    static final String sPolicyNameExceptionMessage       = "xam/invalid policy name.";
    static final String sAuthenticationExceptionMessage   = "xam/authentication exception.";
    
    
    static void throwConvertedException(long inHandle, Exception inException)
            throws XAMException {
        int vErrorCode = 0;
        String vErrorMessage = inException.getMessage();
        
        try {
            vErrorCode = Integer.parseInt(vErrorMessage);
        } catch (Exception e) {
            throw new XAMException(inException);
        }
        throwConvertedException(inHandle, vErrorCode);
    }
    
    static void throwConvertedException(long inHandle, int inErrorCode)
            throws XAMException {
        String vErrorMessage = null;
        
        try {
            vErrorMessage = XAM_Native.XAM_GetErrorToken(inHandle, inErrorCode);
        } catch (Exception e) {
            throw new XAMException(String.valueOf(inErrorCode), inErrorCode);
        }
        
        switch (inErrorCode) {
        case XAMErrors.sXAMException:
            throw new XAMException(vErrorMessage, inErrorCode);
        case XAMErrors.sXAM_OUT_OF_MEMORY:
            throw new java.lang.OutOfMemoryError(vErrorMessage);
        case XAMErrors.sInvalidArgumentException:
        case XAMErrors.sXAM_PARAM_NOT_UTF8:
            throw new InvalidArgumentException(vErrorMessage, inErrorCode);
        case XAMErrors.sXAM_INVALID_HANDLE:
            throw new XAMException(vErrorMessage, inErrorCode);
        case XAMErrors.sInvalidFieldTypeException:
            throw new InvalidFieldTypeException(vErrorMessage, inErrorCode);
        case XAMErrors.sInvalidXStreamModeException:
            throw new InvalidXStreamModeException(vErrorMessage, inErrorCode);
        case XAMErrors.sInvalidXRIException:
            throw new InvalidXRIException(vErrorMessage, inErrorCode);
        case XAMErrors.sInvalidXSetModeException:
            throw new InvalidXSetModeException(vErrorMessage, inErrorCode);
        case XAMErrors.sInvalidFieldNameException:
            throw new InvalidFieldNameException(vErrorMessage, inErrorCode);
        case XAMErrors.sVIMLoadException:
        case XAMErrors.sXAM_VIM_SYMBOL_NOT_FOUND:
            throw new VIMLoadException(vErrorMessage, inErrorCode);
        case XAMErrors.sFieldDoesNotExistException:
            throw new FieldDoesNotExistException(vErrorMessage, inErrorCode);
        case XAMErrors.sFieldReadOnlyException:
            throw new FieldReadOnlyException(vErrorMessage, inErrorCode);
        case XAMErrors.sFieldExistsException:
            throw new FieldExistsException(vErrorMessage, inErrorCode);
        case XAMErrors.sFieldInUseException:
            throw new FieldInUseException(vErrorMessage, inErrorCode);
        case XAMErrors.sMaximumFieldException:
            throw new MaximumFieldException(vErrorMessage, inErrorCode);
        case XAMErrors.sXAM_FILESYSTEM_ERROR:
        case XAMErrors.sXSystemAbandonException:
            throw new XSystemAbandonException(vErrorMessage, inErrorCode);
        case XAMErrors.sXSetAbandonException:
            throw new XSetAbandonException(vErrorMessage, inErrorCode);
        case XAMErrors.sXStreamAbandonException:
            throw new XStreamAbandonException(vErrorMessage, inErrorCode);
        case XAMErrors.sXSystemCorruptException:
            throw new XSystemCorruptException(vErrorMessage, inErrorCode);
        case XAMErrors.sXSetCorruptException:
            throw new XSetCorruptException(vErrorMessage, inErrorCode);
        case XAMErrors.sXStreamCorruptException:
            throw new XStreamCorruptException(vErrorMessage, inErrorCode);
        case XAMErrors.sConnectException:
            throw new ConnectException(vErrorMessage, inErrorCode);
        case XAMErrors.sAuthorizationException:
            throw new AuthorizationException(vErrorMessage, inErrorCode);
        case XAMErrors.sXAM_AUTH_DATA_NEEDED:
        case XAMErrors.sAuthenticationException:
            throw new AuthenticationException(vErrorMessage, inErrorCode);
        case XAMErrors.sInvalidXUIDException:
            throw new InvalidXUIDException(vErrorMessage, inErrorCode);
        case XAMErrors.sXSetDoesNotExistException:
            throw new XSetInaccessibleException(vErrorMessage, inErrorCode);
        case XAMErrors.sAsyncPendingException:
            throw new AsyncPendingException(vErrorMessage, inErrorCode);
        case XAMErrors.sXAM_NOT_SUPPORTED:
        case XAMErrors.sInvalidOperationException:
            throw new InvalidOperationException(vErrorMessage, inErrorCode);
        case XAMErrors.sObjectInUseException:
            throw new ObjectInUseException(vErrorMessage, inErrorCode);
        case XAMErrors.sXAM_NOT_A_JOB:
            throw new JobException(vErrorMessage, inErrorCode);
        case XAMErrors.sJobCommandException:
        case XAMErrors.sXAM_JOB_INVALID_CMD_SYNTAX:
            throw new JobCommandException(vErrorMessage, inErrorCode);
        case XAMErrors.sJobUnsupportedException:
            throw new JobUnsupportedException(vErrorMessage, inErrorCode);
        case XAMErrors.sJobPermissionsException:
            throw new JobPermissionsException(vErrorMessage, inErrorCode);
        case XAMErrors.sJobResourcesException:
            throw new JobResourcesException(vErrorMessage, inErrorCode);
        case XAMErrors.sJobRunningException:
            throw new JobRunningException(vErrorMessage, inErrorCode);
        case XAMErrors.sXSetUnderRetentionException:
            throw new XSetUnderRetentionException(vErrorMessage, inErrorCode);
        case XAMErrors.sXSetUnderHoldException:
            throw new XSetUnderHoldException(vErrorMessage, inErrorCode);
        case XAMErrors.sHoldIdException:
            throw new HoldIdException(vErrorMessage, inErrorCode);
        case XAMErrors.sRetentionValueException:
            throw new RetentionValueException(vErrorMessage, inErrorCode);
        case XAMErrors.sPolicyNameException:
            throw new PolicyNameException(vErrorMessage, inErrorCode);
        case XAMErrors.sXAM_XASYNC_HALTED:
            throw new AsyncHaltedException(vErrorMessage, inErrorCode);            
        case XAMErrors.sPolicyMismatchException:
            throw new PolicyMismatchException(vErrorMessage, inErrorCode);
        default:
            throw new XAMException(vErrorMessage, inErrorCode);
        }
    }
}
