/******************************************************************************
 *
 * Copyright  2007, The Storage Networking Industry Association
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *    - Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *    - Neither the name of The Storage Networking Industry Association (SNIA)
 *      nor the names of its contributors may be used to endorse or promote
 *      products derived from this software without specific prior written
 *      permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ============================================================================
 *  Copyright  2007, EMC Corporation.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *    - Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *    - The name of EMC Corporation may not be used to endorse or promote
 *      products derived from this software without specific prior written
 *      permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/
/*****************************************************************************
 * XAM_Native Version @version.full@
 *****************************************************************************/

package org.snia.xam.natives;

import java.io.ByteArrayOutputStream;

import org.snia.xam.*;

/**
 * A holder for a group of static public methods that turn into native
 * method calls. These native methods support the XAM API.
 *
 * @since 1.0
 */
final public class XAM_Native
{
    public static void loadXAMLibrary() throws Throwable
    {
        System.loadLibrary("xam");
    }

    public static native String
    XAM_GetErrorToken(long inHandle, int inStatus)
    	throws Exception;

    public static native long
    XAM_OpenFieldIterator(long inHandle, String inPattern)
        throws Exception;
    
    public static native boolean
    XAM_ContainsField(long inHandle, String inFieldName)
        throws Exception;
    
    public static native boolean
    XIterator_HasNext(long inHandle)
        throws Exception;

    public static native String
    XIterator_Next(long inHandle)
    	throws Exception;

    public static native void
    XIterator_Close(long inHandle)
    	throws Exception;

    public static native void
    XAM_SetFieldAsBinding(long inHandle, String inName)
    	throws Exception;

    public static native void
    XAM_SetFieldAsNonbinding(long inHandle, String inName)
    	throws Exception;

    public static native String
    XAM_GetFieldType(long inHandle, String inName)
    	throws Exception;

    public static native long
    XAM_GetFieldLength(long inHandle, String inName)
    	throws Exception;

    public static native boolean
    XAM_GetFieldBinding(long inHandle, String inName)
    	throws Exception;

    public static native boolean
    XAM_GetFieldReadOnly(long inHandle, String inName)
    	throws Exception;

    public static native void
    XAM_DeleteField(long inHandle, String inName)
    	throws Exception;

    public static native void
    XAM_CreateBoolean(long inHandle,
                      String inName,
                      boolean inBinding,
                      boolean inValue)
    	throws Exception;

    public static native void
    XAM_CreateInt(long inHandle,
                  String inName,
                  boolean inBinding,
                  long inValue)
    	throws Exception;

    public static native void
    XAM_CreateDouble(long inHandle,
                    String inName,
                    boolean inBinding,
                    double inValue)
    	throws Exception;

    public static native void
    XAM_CreateXUID(long inHandle,
                   String inName,
                   boolean inBinding,
                   byte[] inValue)
    	throws Exception;

    public static native void
    XAM_CreateString(long inHandle,
                     String inName,
                     boolean inBinding,
                     String inValue)
    	throws Exception;

    public static native void
    XAM_CreateDatetime(long inHandle,
                       String inName,
                       boolean inBinding,
                       String inValue)
    	throws Exception;

    public static native void
    XAM_SetBoolean(long inHandle, String inName, boolean inValue)
    	throws Exception;

    public static native void
    XAM_SetInt(long inHandle, String inName, long inValue)
    	throws Exception;

    public static native void
    XAM_SetDouble(long inHandle, 
    		      String inName,
    		      double inValue)
    	throws Exception;

    public static native void
    XAM_SetXUID(long inHandle, 
    		    String inName, 
    		    byte[] inValue)
    	throws Exception;

    public static native void
    XAM_SetString(long inHandle, 
    		      String inName, 
    		      String inValue)
    	throws Exception;

    public static native void
    XAM_SetDatetime(long inHandle, 
    		        String inName, 
    		        String inValue)
    	throws Exception;

    public static native boolean
    XAM_GetBoolean(long inHandle, String inName)
    	throws Exception;

    public static native long
    XAM_GetInt(long inHandle, String inName)
    	throws Exception;

    public static native double
    XAM_GetDouble(long inHandle, String inName)
    	throws Exception;

    public static native byte[]
    XAM_GetXUID(long inHandle, String inName)
    	throws Exception;

    public static native String
    XAM_GetString(long inHandle, String inName)
    	throws Exception;

    public static native String
    XAM_GetDatetime(long inHandle, String inName)
    	throws Exception;

    public static native long
    XAM_CreateXStream(long inHandle,
                      String inName,
                      boolean inBinding,
                      String inType)
    	throws Exception;

    public static native long
    XAM_OpenXStream(long inHandle, String inName, String inMode)
    	throws Exception;

    public static native long
    XStream_Read(long inHandle, byte[] ioBuffer, long inBufferLength)
    	throws Exception;

    public static native long
    XStream_Write(long inHandle, byte[] inBuffer, long inByteCount)
    	throws Exception;

    public static native void
    XStream_Seek(long inHandle, long inOffset, long inWhence)
    	throws Exception;

    public static native long
    XStream_Tell(long inHandle)
    	throws Exception;

    public static native void
    XStream_Abandon(long inHandle)
    	throws Exception;

    public static native void
    XStream_Close(long inHandle)
    	throws Exception;

    public static native long
    XAM_Connect(String inXRI)
    	throws Exception;

    public static native long
    XSystem_Authenticate(long inHandle, 
    		             byte[] inBuffer, 
    		             long inByteCount)
    	throws Exception;

    public static native int
    XSystem_Authenticate2(long inHandle, 
                         byte[] inBuffer, 
                         long inByteCount,
                         ByteArrayOutputStream response)
        throws Exception;

    
    public static native void
    XSystem_Close(long inHandle)
    	throws Exception;

    public static native void
    XSystem_Abandon(long inHandle)
    	throws Exception;

    public static native long
    XSystem_CreateXSet(long inHandle, String inMode)
    	throws Exception;

    public static native long
    XSystem_OpenXSet(long inHandle, byte[] inXUID, String inMode)
    	throws Exception;
    
    public static native long
    XSystem_CopyXSet(long inHandle, byte[] inXUID, String inMode)
    	throws Exception;
    
    public static native void
    XSystem_DeleteXSet(long inHandle, byte[] inXUID)
    	throws Exception;
    
    public static native boolean
    XSystem_IsXSetRetained(long inHandle, byte[] inXUID)
        throws Exception;
    
    public static native void
    XSystem_HoldXSet(long inHandle, byte[] inXUID, String inHoldID)
    	throws Exception;

    public static native void
    XSystem_ReleaseXSet(long inHandle, byte[] inXUID, String inHoldID)
    	throws Exception;

    public static native boolean
    XSystem_AccessXSet(long inHandle, byte[] inXUID, long inMode)
    	throws Exception;

    public static native String
    XSystem_GetXSetAccessTime(long inHandle, byte[] inXUID)
    	throws Exception;

    public static native byte[]
    XSet_Commit(long inHandle)
    	throws Exception;

    public static native void
    XSet_Close(long inHandle)
    	throws Exception;
    
    public static native void
    XSet_Abandon(long inHandle)
    	throws Exception;
    
    public static native void
    XSet_ApplyAccessPolicy(long inHandle,
                               boolean inBinding,
                               String inPolicy)
    	throws Exception;

    public static native void
    XSet_ResetAccessFields(long inHandle)
    	throws Exception;
    
    public static native void
    XSet_ApplyManagementPolicy(long inHandle,
                               boolean inBinding,
                               String inPolicy)
    	throws Exception;
    
    public static native void
    XSet_ResetManagementFields(long inHandle)
    	throws Exception;

    public static native void
    XSet_ApplyAutoDeletePolicy(long inHandle,
                               boolean inBinding,
                               String inPolicy)
    	throws Exception;

    public static native void
    XSet_SetAutoDelete(long inHandle,
                       boolean inBinding,
                       boolean inAutoDelete)
    	throws Exception;

    public static native void
    XSet_ApplyShredPolicy(long inHandle,
    					  boolean inBinding,
    					  String inPolicy)
    	throws Exception;

    public static native void
    XSet_ApplyStoragePolicy(long inHandle,
                            boolean inBinding,
                            String inPolicy)
    	throws Exception;


    public static native boolean
    XSet_GetActualAutoDelete(long inHandle)
    	throws Exception;

    public static native boolean
    XSet_GetActualShred(long inHandle)
    	throws Exception;
    
    public static native void
    XSet_CreateRetention(long inHandle, 
    					 boolean inBinding, 
    					 String inRetentionID) throws Exception;
    
    public static native void
    XSet_SetRetentionEnabledFlag(long mHandle, 
    							 String retentionID, 
    							 boolean binding, 
    							 boolean enabled) throws Exception;
    public static native void
    XSet_ApplyRetentionEnabledPolicy(long mHandle, 
    							 		String retentionID, 
    							 		boolean binding, 
    							 		String  policyName) throws Exception;
    
    public static native void
    XSet_SetRetentionDuration(long mHandle, 
    						   String retentionId, 
    						   boolean binding, 
    						   long duration) throws Exception;
    
    public static native void
    XSet_ApplyRetentionDurationPolicy(long mHandle, 
    							 	  String retentionID, 
    							 	  boolean binding, 
    							 	  String  policyName) throws Exception;
    
    public static native void
    XSet_SetRetentionStarttime(long mHandle, 
    							 	  String retentionID, 
    							 	  boolean binding) throws Exception;
    public static native void
    XSet_SetBaseRetention(long mHandle, 
    					  boolean binding, 
    					  long duration) throws Exception;
    
    public static native void
    XSet_ApplyBaseRetentionPolicy(long mHandle, 
   							 	  boolean binding, 
   							 	  String  policyName) throws Exception;
    
    public static native void
    XSet_SetShred(long mHandle, 
    			  boolean binding, 
    			  boolean shred) throws Exception;
    
    public static native long
    XSet_GetActualRetentionDuration(long mHandle, 
    								String retentionID) throws Exception;
    
    public static native boolean
    XSet_GetActualRetentionEnabled(long mHandle, 
    								String retentionID) throws Exception;
    
    
    
    public static native long
    XSet_OpenExportXStream(long inHandle)
    	throws Exception;

    public static native long
    XSet_OpenImportXStream(long inHandle)
    	throws Exception;

    public static native void
    XSet_SubmitJob(long inHandle)
    	throws Exception;

    public static native void
    XSet_HaltJob(long inHandle)
    	throws Exception;
    
    public static native XAsync
    XSystem_AsyncOpenXSet(long inHandle,
    					  byte[] inXUID,
    					  String inMode,
    					  long inXOPID,
    					  XAsyncListener inCallback)
    	throws Exception; 
    
    public static native XAsync
    XSystem_AsyncCopyXSet(long inHandle,
    					  byte[] inXUID,
    					  String inMode,
    					  long inXOPID,
    					  XAsyncListener inCallback)
    	throws Exception;
    
    public static native XAsync 
    XAM_AsyncOpenXStream(long inHandle,
                         String inName,
                         String inMode,
                         long inXOPID,
                         XAsyncListener inCallback)
    	throws Exception;	
    
    public static native XAsync
    XStream_AsyncRead(long inHandle,
    				  byte[] ioBuffer,
    				  long inBufferLength,
    				  long inXOPID,
    				  XAsyncListener inCallback)
    	throws Exception;
    
    public static native XAsync 
    XStream_AsyncWrite(long inHandle,
    				   byte[] inBuffer,
    				   long inByteCount,
    				   long inXOPID,
    				   XAsyncListener inCallback)
    	throws Exception;
    
    public static native XAsync
    XSet_AsyncCommit(long inHandle,
    				 long inXOPID,
    				 XAsyncListener inCallback)
    	throws Exception;
    
    public static native XAsync 
    XStream_AsyncClose(long inHandleXStream,
    				   long inXOPID,
    				   XAsyncListener inCallback,
    				   XStream inObj)
    throws Exception;
    
    public static native void
    XAsync_Halt(long inHandle)
    	throws Exception;	

    public static native boolean
    XAsync_IsComplete(long inHandle)
    	throws Exception;

    
    public static native int
    XAsync_GetStatus(long inHandle)
    	throws Exception;
    
    public static native long
    XAsync_GetXOPID(long inHandle)
    	throws Exception;
    
    public static native long
    XAsync_GetXSet(long inHandle)
    	throws Exception;
    
    public static native long
    XAsync_GetXStream(long inHandle)
    	throws Exception;
    
    public static native byte[]
    XAsync_GetXUID(long inHandle)
    	throws Exception;
    
    public static native long
    XAsync_GetBytesRead(long inHandle)
    	throws Exception;
    
    public static native long
    XAsync_GetBytesWritten(long inHandle)
    	throws Exception;
    
    public static native void
    XAsync_Close(long inHandle)
    	throws Exception;
    
}
