/*
 * Copyright (c) 2009, Storage Networking Industry Association
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *      * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 *      * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 *      * Neither the name of Storage Networking Industry Association
 * nor the names of its contributors may be used to endorse or promote
 * products derived from this software without specific prior written
 * permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

/* Copyright (c) 2007, Sun Microsystems, Inc.                                       */

package org.snia.xam.vim.isolation.server.util;

import org.snia.xam.XAsync;

/**
 * An entry in the cache with all necessary information for maintaining the XAsync
 * and retrieving information about the XAsync operation.
 */
public class XAsyncCacheEntry {
    
    private XAsync async         = null;
    private long   xsystemHandle = -1;
    private long   handle        = -1;
    private byte   buffer[]      = null;   // Used if the request was an asyncRead.
    
    /** Creates a new instance of XSetCacheEntry */
    public XAsyncCacheEntry(long xsystemHandle, XAsync async, long handle) {
        this.xsystemHandle = xsystemHandle;
        this.async         = async;
        this.handle        = handle;
    }
    
    public XAsync getXAsync() {
        return async;
    }
    
    public long getHandle() {
        return handle;
    }
    
    public long getXSystemHandle() {
        return xsystemHandle;
    }
    
    public void setBuffer( byte buf[] ) {
       buffer = buf;
    }
    
    public byte[] getBuffer() { return buffer; }
}
