/*
 *  Copyright (c) 2008, Sun Microsystems, Inc.
 *  Copyright (c) 2008, The Storage Networking Industry Association.
 * 
 *  Redistribution and use in source and binary forms, with or without modification, 
 *  are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.
 * 
 *  *  Neither the name of The Storage Networking Industry Association (SNIA) nor 
 *     the names of its contributors may be used to endorse or promote products 
 *     derived from this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
 *  THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.snia.xam.vim.reference;

/**
 *
 */
public class XAMConstants {
    
    public static final String UTF_8 = "UTF-8";
    public static final String XRI_DIR_PARAM_NAME = "dir";
    
    /* Name of the current VIM.
     * This name/key is loaded into the XAM library and associated with the
     * class name that implements the SNIA Reference VIM.
     */
    public static final String REFERENCE_VIM_NAME = "SNIA_Reference_VIM";
    
    // SNIA Reference VIM Namespace prefix
    public static final String SNIA_REFVIM_PREFIX =
            "org.snia.refvim.";
    public static final String AT_SNIA_ORG = "@snia.org";
    
    public static final long XSTREAM_MAX_SIZE = Long.MAX_VALUE;
    public static final long MILLISEC_PER_SECOND = 1000;
    public static final long END_OF_STREAM = -1;
    
    public static final String XAM_JOB = ".xam.job.";
    public static final String JOB_ID_PREFIX = "JOBID_";
    public static final String NO_JOB_ID = JOB_ID_PREFIX + "_NOT_SET";
    public static final String EMPTY_STRING = "";
    public static final String EMPTY_SPACE = " ";
    public static final String EQUALS_SIGN = "=";
    public static final String SINGLE_QUOTE = "\'";
    public static final String DOUBLE_QUOTE = "\"";
   
}
