/*
 *  Copyright (c) 2008, Sun Microsystems, Inc.
 *  Copyright (c) 2008, The Storage Networking Industry Association.
 * 
 *  Redistribution and use in source and binary forms, with or without modification, 
 *  are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.
 * 
 *  *  Neither the name of The Storage Networking Industry Association (SNIA) nor 
 *     the names of its contributors may be used to endorse or promote products 
 *     derived from this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
 *  THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.snia.xam.vim.reference;

/**
 *
 */
public class XmlConstants {
    
    public static final String XML_HEADER = 
            "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
    public static final String XAM_VERSION = "<version>1.0.0</version>";
    
    public static final String TAG_XSETS      = "xsets";
    public static final String TAG_XSET       = "xset";
    public static final String TAG_POLICY     = "policy";
    public static final String TAG_POLICIES   = "policies";
    public static final String TAG_PROPERTIES = "properties";
    public static final String TAG_PROPERTY   = "property";
    public static final String TAG_VALUE      = "value";
    public static final String TAG_VERSION    = "version";
    public static final String TAG_XSTREAMS   = "xstreams";
    
    public static final String TAG_BOOLEAN = "boolean";
    public static final String TAG_INTEGER = "integer";
    public static final String TAG_DOUBLE  = "double";
    public static final String TAG_STRING  = "string";
    public static final String TAG_XSTREAM = "xstream";
    public static final String TAG_XUID    = "xuid";
    public static final String TAG_DATE    = "date";
    public static final String TAG_XSTREAM_DATA = 
            XAMConstants.SNIA_REFVIM_PREFIX + "xstream_data" ;
    public static final String TAG_XSTREAM_XOP_INCLUDE = "xop:Include";
    
    public static final String ATTRIBUTE_BINDING   = "binding";
    public static final String ATTRIBUTE_LENGTH    = "length";
    public static final String ATTRIBUTE_NAME      = "name";
    public static final String ATTRIBUTE_READONLY  = "readOnly";
    public static final String ATTRIBUTE_TYPE      = "type";
    public static final String ATTRIBUTE_HREF      = "href";
    public static final String ATTRIBUTE_XMLNS_XOP = "xmlns:xop";
    public static final String ATTRIBUTE_CID = "cid:";
    
    // Export Constants
    public static final String CONTENT_TYPE_HEADER = "Content-Type:";
    public static final String CONTENT_DESC_HEADER = "Content-Description:";
    public static final String CONTENT_TRANSER_ENCODING_HEADER = 
            "Content-Transfer-Encoding:";
    public static final String CONTENT_ID_HEADER = "Content-ID:";
    public static final String ATTRIBUTE_START = "start";
    public static final String ATTRIBUTE_START_INFO = "start-info";
    
    //
    public static final String ATTRIBUTE_CHARSET = "charset";

    // Content Transfer Types - Note these are case insensitive
    public static final String  TRANSFER_TYPE_8BIT = "8bit";
    public static final String TRANSFER_TYPE_BINARY = "binary";
    public static final String TRANSFER_TYPE_BASE64 = "base64";
    public static final String TRANSER_TYPE_TEXT = "text";
    
    // Content Types
    public static final String CONTENT_TYPE_TEXT = "text";
    public static final String CONTENT_TYPE_IMAGE = "image";
    public static final String CONTENT_TYPE_APPLICATION = "application";
    public static final String CONTENT_TYPE_VIDEO = "video";
    public static final String CONTENT_TYPE_AUDIO = "audio";
    
    
    public static final String CONTENT_SUBTYPE_XOP = "xop+xml";
    public static final String CONTENT_SUBTYPE_XML = "xml";
    public static final String CONTENT_SUBTYPE_TEXT = "text";
    public static final String CONTENT_SUBTYPE_JPEG = "jpeg";
    
    public static final String CONTENT_TYPE_APPLICATION_XOP =
            CONTENT_TYPE_APPLICATION + "/" + CONTENT_SUBTYPE_XOP;
    // Content Ids
    public static final String TOC_CONTENT_ID_VALUE = "<TOC>";
    public static final String DESC_TEXT = "Export of XSet: ";
    public static final String XSET_CONTENT_ID_VALUE = 
            "<canonicalxset.xml@snia.org>";
    
    // Constant Attribute Values
    public static final String XMLNS_XOP_VALUE = 
            "http://www.w3.org/2004/08/xop/include";
    
    // Export TOC Offset Prefix
    public static final String TOC_OFFSET_TEXT = "Offset of ";
}
