/* Copyright (c) 2009, The Storage Networking Industry Association.
   (c) Copyright 2009 Hewlett-Packard Development Company, L.P.
   
 Redistribution and use in source and binary forms, with or without modification, 
 are permitted provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, 
 this list of conditions and the following disclaimer.
 
 * Redistributions in binary form must reproduce the above copyright notice, 
 this list of conditions and the following disclaimer in the documentation 
 and/or other materials provided with the distribution.
 
 * Neither the name of The Storage Networking Industry Association (SNIA) nor 
 the names of its contributors may be used to endorse or promote products 
 derived from this software without specific prior written permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
 THE POSSIBILITY OF SUCH DAMAGE.
 */

package org.snia.xam.vim.reference.query;

public interface FactorNode
    extends WhereNode
{
    // Factor operators
    // Unary operators
    public static final int VALUE_OF        = 0; // Bareword property name
    public static final int VALUE_TYPEOF    = 200;
    public static final int VALUE_READONLY  = 201;
    public static final int VALUE_BINDING   = 202;
    public static final int VALUE_LENGTH    = 203;

    // These functions are Unary and do not represent legal binary ops + literal
    public static final int EXISTS          = 204;
    
    // Binary operators
    public static final int FUNCTION_NONE    = 0;
    public static final int EQUALS           = 100;
    public static final int NOT_EQUALS       = 101;
    public static final int LESS_THAN        = 102;
    public static final int LESS_THAN_EQ     = 103;
    public static final int GREATER_THAN     = 104;
    public static final int GREATER_THAN_EQ  = 105;
    public static final int LIKE             = 106;

    // Level 2 operators
    public static final int CONTAINS         = 150;
    public static final int BEFORE           = 151;
    public static final int AFTER            = 152;
    public static final int WITHIN           = 153;
    
    public int getOperator();
    public int getValueRef();
    public String getProperty();
    public AnnotatedLiteral getExpression();
    
    public boolean isOperatorUnary();
}
