/* Copyright (c) 2009, The Storage Networking Industry Association.
   (c) Copyright 2009 Hewlett-Packard Development Company, L.P.
   
 Redistribution and use in source and binary forms, with or without modification, 
 are permitted provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, 
 this list of conditions and the following disclaimer.
 
 * Redistributions in binary form must reproduce the above copyright notice, 
 this list of conditions and the following disclaimer in the documentation 
 and/or other materials provided with the distribution.
 
 * Neither the name of The Storage Networking Industry Association (SNIA) nor 
 the names of its contributors may be used to endorse or promote products 
 derived from this software without specific prior written permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
 THE POSSIBILITY OF SUCH DAMAGE.
 */

package org.snia.xam.vim.reference.query;

import java.util.Enumeration;
import java.util.Vector;

public class FunctionExpression
   implements FactorNode
{
   String m_propName;

   int m_operator;

   Vector<Object> m_arguments;

   public void setProperty(String propertyName)
   {
      m_propName = propertyName;
   }

   public void setOperator(int op)
   {
      m_operator = op;
   }

   public void setArguments(Vector<Object> args)
   {
      m_arguments = args;
   }

   public boolean isOperatorUnary()
   {
      return false;
   }

   public AnnotatedLiteral getExpression()
   {
      return null;
   }

   public String getProperty()
   {
      return m_propName;
   }

   public int getOperator()
   {
      return m_operator;
   }

   public boolean isFactor()
   {
      return false;
   }

   public boolean isTerm()
   {
      return true;
   }

   public boolean isParenthesis()
   {
      return false;
   }

   public String toString()
   {
      StringBuffer buf = new StringBuffer("\"");
      buf.append(m_propName);
      buf.append("\" ");
      buf.append(m_operator);
      buf.append("(");
      Enumeration<Object> e = m_arguments.elements();
      int count = 0;
      while (e.hasMoreElements())
      {
         if (count++ > 0) buf.append(", ");
         String arg = (String) e.nextElement();
         buf.append(arg);
      }
      buf.append(")");

      return buf.toString();
   }

   public int getValueRef()
   {
      // TODO Auto-generated method stub
      return 0;
   }
}