/*
 *  Copyright (c) 2008, Hewlett-Packard Development Company, L.P.
 *  Copyright (c) 2009, Sun Microsystems, Inc.
 *  Copyright (c) 2008-2009, The Storage Networking Industry Association.
 * 
 *  Redistribution and use in source and binary forms, with or without modification, 
 *  are permitted provided that the following conditions are met:
 * 
 *  *  Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer.
 * 
 *  *  Redistributions in binary form must reproduce the above copyright notice, 
 *     this list of conditions and the following disclaimer in the documentation 
 *     and/or other materials provided with the distribution.
 * 
 *  *  Neither the name of The Storage Networking Industry Association (SNIA) nor 
 *     the names of its contributors may be used to endorse or promote products 
 *     derived from this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED FBY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
 *  THE POSSIBILITY OF SUCH DAMAGE.
 */

package org.snia.xam.vim.reference;

import org.snia.xam.vim.reference.query.QueryFactoryTest;

import junit.framework.Test;
import junit.framework.TestSuite;

public class AllTest extends ReferenceXAMTest
{
	public static void main(String[] args)
	{
    	System.exit(runTest(args, suite()));
	}

	public static Test suite()
	{
		TestSuite suite = new TestSuite();
      suite.addTest(XAMTest.suite());
      suite.addTest(ReferenceXAMTest.suite());
      suite.addTest(ReferenceAuthenticationTest.suite());
      suite.addTest(SniaXUIDTest.suite());
      suite.addTest(ReferenceXSystemTest.suite());
      suite.addTest(ReferenceXSetTest.suite());
      suite.addTest(ReferenceXStreamTest.suite());
      suite.addTest(DeleteXSetTest.suite());
      suite.addTest(ExportImportTest.suite());
      suite.addTest(ReferenceIteratorTest.suite());
      suite.addTest(ReferenceQueryTest.suite());
      suite.addTest(ReferenceQuerySemanticTest.suite());
      suite.addTest(AccessPolicyTest.suite());
      suite.addTest(LitigationHoldTest.suite());
      suite.addTest(DispositionTest.suite());
      suite.addTest(QueryFactoryTest.suite());
      suite.addTest(AsynchronousOperationTest.suite());
      
      System.out.println("");
      System.out.println("***************  IMPORTANT  ********************");
      System.out.println("The retention tests are NOT run by default.");
      System.out.println("To run them, use the ant target:  test_retention");
      System.out.println("************************************************");
      System.out.println("");
      return suite;
	}
	
	public AllTest(String name)
	{
		super(name);
	}
}
