/* Copyright (c) 2008, The Storage Networking Industry Association.

 Redistribution and use in source and binary forms, with or without modification, 
 are permitted provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, 
 this list of conditions and the following disclaimer.
 
 * Redistributions in binary form must reproduce the above copyright notice, 
 this list of conditions and the following disclaimer in the documentation 
 and/or other materials provided with the distribution.
 
 * Neither the name of The Storage Networking Industry Association (SNIA) nor 
 the names of its contributors may be used to endorse or promote products 
 derived from this software without specific prior written permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
 THE POSSIBILITY OF SUCH DAMAGE.
 */

/* (c) Copyright 2008 Hewlett-Packard Development Company, L.P. */

package org.snia.xam;

import junit.framework.Test;
import junit.framework.TestSuite;
import org.snia.xam.base.TestAbstractFieldContainer;
import org.snia.xam.base.DefaultXUIDTest;
import org.snia.xam.base.ExceptionTest;
import org.snia.xam.base.ISO8601Test;
import org.snia.xam.base.LoggingTest;
import org.snia.xam.base.XRITest;
import org.snia.xam.util.QueryFactoryTest;
import org.snia.xam.util.XAMLibraryFactoryTest;
import org.snia.xam.util.XUIDIteratorTest;

public class AllTest
   extends XAMTest
{
   public static void main(String[] args)
   {
      System.exit(runTest(args, suite()));
   }

   public static Test suite()
   {
      TestSuite suite = new TestSuite();
      suite.addTest(TestVIMConfiguration.suite());
      suite.addTest(DefaultXUIDTest.suite());
      suite.addTest(ISO8601Test.suite());
      suite.addTest(LoggingTest.suite());
      suite.addTest(ExceptionTest.suite());
      suite.addTest(XRITest.suite());
      suite.addTest(XAMLibraryFactoryTest.suite());
      suite.addTest(TestAbstractFieldContainer.suite());
      suite.addTest(XAMTest.suite());
      suite.addTest(QueryFactoryTest.suite());
      suite.addTest(XUIDIteratorTest.suite());
      return suite;
   }

   public AllTest(String name)
   {
      super(name);
   }
}
