/* Copyright (c) 2008, The Storage Networking Industry Association.

   Redistribution and use in source and binary forms, with or without modification, 
   are permitted provided that the following conditions are met:

   * Redistributions of source code must retain the above copyright notice, 
   this list of conditions and the following disclaimer.
   
   * Redistributions in binary form must reproduce the above copyright notice, 
   this list of conditions and the following disclaimer in the documentation 
   and/or other materials provided with the distribution.
   
   * Neither the name of The Storage Networking Industry Association (SNIA) nor 
   the names of its contributors may be used to endorse or promote products 
   derived from this software without specific prior written permission.
   
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
   THE POSSIBILITY OF SUCH DAMAGE.
*/

/* (c) Copyright 2008 Hewlett-Packard Development Company, L.P. */

package org.snia.xam.testvim;

import java.util.Calendar;

import org.snia.xam.AuthenticationException;
import org.snia.xam.AuthenticationExpiredException;
import org.snia.xam.AuthorizationException;
import org.snia.xam.FieldDoesNotExistException;
import org.snia.xam.FieldExistsException;
import org.snia.xam.InvalidArgumentException;
import org.snia.xam.InvalidFieldNameException;
import org.snia.xam.InvalidOperationException;
import org.snia.xam.JobCommandException;
import org.snia.xam.JobRunningException;
import org.snia.xam.JobUnsupportedException;
import org.snia.xam.MaximumFieldException;
import org.snia.xam.ObjectInUseException;
import org.snia.xam.PolicyNameException;
import org.snia.xam.RetentionValueException;
import org.snia.xam.XAMException;
import org.snia.xam.XAMLibrary;
import org.snia.xam.XAsync;
import org.snia.xam.XAsyncListener;
import org.snia.xam.XSet;
import org.snia.xam.XSetAbandonException;
import org.snia.xam.XSetCorruptException;
import org.snia.xam.XSetUnderHoldException;
import org.snia.xam.XStream;
import org.snia.xam.XSystem;
import org.snia.xam.XSystemAbandonException;
import org.snia.xam.XSystemCorruptException;
import org.snia.xam.XUID;
import org.snia.xam.base.AbstractFieldContainer;
import org.snia.xam.base.Property;

public class TestXSet
   extends AbstractFieldContainer
   implements XSet
{
   XSystem m_xsystem;
   XUID    m_xuid;
   
   /**
    * Create a new TestXSet, and track the commit mode.
    * @param xsys
    * @param post_commit_mode
    * @throws XAMException
    */
   public TestXSet( XSystem xsys, String post_commit_mode ) throws XAMException
   {
      m_xsystem = xsys;
      createNewBornProperties();
   }
   
   void  createNewBornProperties() throws XAMException
   {
       addField(new Property(XSet.XAM_TIME_CREATION,
           XAMLibrary.STYPE_DATETIME_MIME_TYPE,
           Calendar.getInstance(),
           true,
           true  ));
   }

   public void abandon()
      throws AuthenticationExpiredException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void applyAccessPolicy(boolean binding, String policyName)
      throws AuthenticationExpiredException, MaximumFieldException, PolicyNameException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void applyAutoDeletePolicy(boolean binding, String policyName)
      throws AuthenticationExpiredException, PolicyNameException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void applyBaseRetentionPolicy(boolean binding, String policyName)
      throws AuthenticationExpiredException, InvalidArgumentException, InvalidFieldNameException, PolicyNameException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void applyManagementPolicy(boolean binding, String policyName)
      throws MaximumFieldException, PolicyNameException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void applyRetentionDurationPolicy(String retentionID, boolean binding, String inPolicy)
      throws AuthenticationExpiredException, InvalidArgumentException, InvalidFieldNameException, PolicyNameException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void applyRetentionEnabledPolicy(String retentionID, boolean binding, String policy)
      throws AuthenticationExpiredException, InvalidArgumentException, InvalidFieldNameException, PolicyNameException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void applyShredPolicy(boolean binding, String policyName)
      throws AuthenticationExpiredException, MaximumFieldException, PolicyNameException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void applyStoragePolicy(boolean binding, String policyName)
      throws AuthenticationExpiredException, MaximumFieldException, PolicyNameException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public XAsync asyncCommit(long xopid, XAsyncListener listener)
      throws AuthenticationExpiredException, InvalidArgumentException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      return null;
   }

   public void close()
      throws AuthenticationExpiredException, ObjectInUseException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public XUID commit()
      throws AuthenticationExpiredException, AuthorizationException, JobRunningException, XSetUnderHoldException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      if( m_xuid == null )
      {
         m_xuid = TestXUID.newXUID();
         addField(new Property(XSet.XAM_TIME_XUID,
            XAMLibrary.STYPE_DATETIME_MIME_TYPE,
            Calendar.getInstance(),
            true,
            true  ));
         
         addField( new Property(XSet.XAM_XUID,
            XAMLibrary.STYPE_XUID_MIME_TYPE,
            m_xuid,
            true,
            true ));
      }
      return m_xuid;
   }

   public void createRetention(boolean binding, String retentionID)
      throws AuthenticationExpiredException, InvalidArgumentException, InvalidFieldNameException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public boolean getActualAutoDelete()
      throws AuthenticationExpiredException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      return false;
   }

   public long getActualRetentionDuration(String retentionID)
      throws AuthenticationExpiredException, InvalidArgumentException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      return 0;
   }

   public boolean getActualRetentionEnabled(String retentionID)
      throws AuthenticationExpiredException, InvalidArgumentException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      return false;
   }

   public boolean getActualShred()
      throws AuthenticationExpiredException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      return false;
   }

   public void haltJob()
      throws AuthorizationException, AuthenticationException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }
   
   public void testJobSetStatus( String status ) 
      throws XAMException
   {
      this.setProtectNamespace(false);
      addField(new Property(XSet.XAM_JOB_STATUS,
         XAMLibrary.STYPE_STRING_MIME_TYPE,
         status,
         false,
         true  ));
      this.setProtectNamespace(true);
   }

   public XStream openExportXStream()
      throws XAMException
   {
      // TODO Auto-generated method stub
      return null;
   }

   public XStream openImportXStream()
      throws AuthenticationExpiredException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      return null;
   }

   public void resetAccessFields()
      throws AuthenticationExpiredException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void resetManagementFields()
      throws AuthenticationExpiredException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void setAutoDelete(boolean binding, boolean autoDelete)
      throws AuthenticationExpiredException, MaximumFieldException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void setBaseRetention(boolean binding, long duration)
      throws AuthenticationExpiredException, RetentionValueException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void setRetentionDuration(String retentionID, boolean binding, long duration)
      throws AuthenticationExpiredException, InvalidArgumentException, InvalidFieldNameException, RetentionValueException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void setRetentionEnabledFlag(String retentionID, boolean binding, boolean enabled)
      throws AuthenticationExpiredException, InvalidArgumentException, InvalidFieldNameException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void setRetentionStarttime(String retentionID, boolean binding)
      throws AuthenticationExpiredException, FieldExistsException, InvalidArgumentException, InvalidFieldNameException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void setShred(boolean binding, boolean shred)
      throws AuthenticationExpiredException, MaximumFieldException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public void submitJob()
      throws AuthenticationExpiredException, AuthorizationException, JobCommandException, JobUnsupportedException, XSetAbandonException, XSetCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      
   }

   public XAsync asyncOpenXStream(String name, String mode, long xopid, XAsyncListener listener)
      throws AuthenticationExpiredException, InvalidArgumentException, InvalidFieldNameException, FieldDoesNotExistException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XSystemAbandonException, XSystemCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      return null;
   }

   public XStream createXStream(String fieldName, boolean binding, String mimeType)
      throws AuthenticationExpiredException, InvalidArgumentException, InvalidFieldNameException, InvalidOperationException, FieldExistsException, MaximumFieldException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XSystemAbandonException, XSystemCorruptException, XAMException
   {
      TestXStream xs = new TestXStream( fieldName, binding, false /*ro*/, mimeType );
      this.addField( xs );
      return xs;
   }

   public XStream openXStream(String fieldName, String mode)
      throws AuthenticationExpiredException, InvalidFieldNameException, FieldDoesNotExistException, ObjectInUseException, XSetAbandonException, XSetCorruptException, XSystemAbandonException, XSystemCorruptException, XAMException
   {
      // TODO Auto-generated method stub
      return null;
   } 

}
