# configure variables for snaixam build
ANT=ant
GPP=$(shell which g++)
CCOVERRIDE=$(GPP)
LDOVERRIDE=$(GPP)

GPP_VERSION=$(shell g++ --version|head -n 1|cut -d ' ' -f 4 )
GPPMAJOR=$(shell echo $(GPP_VERSION)|cut -d '.' -f 1 )

JAVA_HOME=$(shell dpkg -L sun-java5-jdk|grep 'jni\.h'| sed -e 's/\/include.*//'; )
JAVACC_HOME=$(shell dpkg -L javacc|grep "javacc\.jar"|sed -e 's/javacc\.jar//'; )
MAIL_JAR=$(shell dpkg -L libgnumail-java|grep "gnumail\.jar" )
JAF_JAR=$(shell dpkg -L libgnujaf-java|grep "activation\.jar" ) 
LUCENE_JAR=$(shell dpkg -L liblucene2-java|grep "lucene-core\.jar" )
JAR_LIBS=$(LUCENE_JAR):$(MAIL_JAR):$(JAF_JAR)

ifeq ($(GPPMAJOR),3)
    GPPVER=GCC3.3
endif
ifeq ($(GPPMAJOR),4)  
    GPPVER=GCC4
endif
ifeq ($(GPPVER), )
	$(error Unsupported g++ version $(GPP_VERSION))
endif

MACHINE=$(shell uname -m)
ifeq ($(MACHINE),i386) 
	TARGET=32
endif
ifeq ($(MACHINE),i586)
	TARGET=32
endif
ifeq ($(MACHINE),i686)
	TARGET=32
endif
ifeq ($(MACHINE),ia64)
	TARGET=64
endif
ifeq ($(MACHINE),x86_64) 
	TARGET=64
endif
ifeq ($(TARGET), )
	$(error Unable to determine architecture for $(MACHINE))
endif

SDK_MAJOR=$(shell grep "sdk.major" package.properties|cut -d '=' -f2)
SDK_MINOR=$(shell grep "sdk.minor" package.properties|cut -d '=' -f2)
SDK_REV=$(shell grep "sdk.rev" package.properties|cut -d '=' -f2)
FILE_EXT=$(SDK_MAJOR).$(SDK_MINOR).$(SDK_REV)
SONAME_EXT=$(SDK_MAJOR)
DEB_INST_ROOT=debian/tmp
PKG_NAME=sniaxam
PKG_VER=$(FILE_EXT)
JAR_DIR=usr/share/java/$(PKG_NAME)-java$(SDK_MAJOR)
DELIVER_DIR=C_XAM_Library/deliverables/Linux-$(GPPVER)
JAVA_DOC_DIRS=Java_XAM_Library Java_Reference_VIM Java_Interfaces
JAVADOC_DIR=usr/share/javadoc
JNI_DIR=usr/lib/java
