#  Redistribution and use in source and binary forms, with or without 
#  modification, are permitted provided that the following conditions 
#  are met:
#    - Redistributions of source code must retain the above copyright notice,
#      this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above copyright 
#      notice, this list of conditions and the following disclaimer in the 
#      documentation and/or other materials provided with the distribution.
#    - Neither the name of The Storage Networking Industry Association (SNIA)
#      nor the names of its contributors may not be used to endorse or promote 
#      products derived from this software without specific prior written 
#      permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
#  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
#  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
#  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
#  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
#  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
#  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
#  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
#  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
#  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
#  THE POSSIBILITY OF SUCH DAMAGE.
# ============================================================================
# The following are all copyright holders:
# (c) Copyright 2007, EMC Corporation.
# (c) Copyright 2007-2009, The Storage Networking Industry Association.
# (c) Copyright 2007-2009 Sun Microsystems, Inc.
# (c) Copyright 2008-2009 Hewlett-Packard Development Company, L.P. 

Summary: SNIA XAM LIBRARY
Name: sniaxam
Version: 0.3.0
Release:1%{?dist}
Epoch: 0
License: BSD
Group: Development/Libraries
Source: %{name}-%{version}.tar.gz 
URL: http://www.snia.org/forums/xam/technology/software 
BuildRoot: %{_tmppath}/%{name}-root
Requires: /sbin/ldconfig
ExclusiveOs: linux


%description
Reference implementation of the SNIA XAM interface 
 C library and associated reference VIM and test suites.

##############################
%package devel
Summary: SNIA XAM LIBRARY C SDK
Group: Development/Libraries
# ensure libraries match headers
Requires: %{name} = %{version}-%{release} 
%description devel
SNIA XAM interface library C header files and documentation
 for developing XAM applications and associated reference VIMs.

##############################
%package java
Summary: SNIA XAM JAVA SDK
Group: Development/Libraries
# ensure libraries match headers
#Requires: %{name} = %{version}-%{release} 
%description java
SNIA XAM interface library JAVA files for developing
 XAM applications and associated reference VIMs.

##############################
%package javadoc
Summary: SNIA XAM LIBRARY C SDK
Group: Development/Libraries
# ensure libraries match headers
Requires: %{name}-java = %{version}-%{release} 
BuildRequires: doxygen >= 1.4.0
%description javadoc
SNIA XAM interface library JAVA documentation for developing
 XAM applications and associated reference VIMs.


%prep
%setup -q
##############################

%build
# run ant from the top level build file
# builds Java_Interfaces, Java_XAM_Library and Java_Reference_VIM
# ReferenceVIMtest and associated docs.
JAVACC_HOME=`rpm -ql javacc|grep "javacc\.jar"|sed -e 's/javacc\.jar//'`
ant deliverables doc -Djavacc.home=${JAVACC_HOME}

# build C_XAM_Library
##############################
pushd `pwd`
cd C_XAM_Library/build_script
GPP=`which g++`
CCOVERRIDE=${GPP}
LDOVERRIDE=${GPP}

# set g++ version >=3.3 or >=4.0
# build layout requires it
GPP_VERSION=`g++ --version|head -n 1|cut -d ' ' -f 3`
GPPMAJOR=`echo ${GPP_VERSION}|cut -d '.' -f 1`
GPPMINOR=`echo ${GPP_VERSION}|cut -d '.' -f 2`
if [  ${GPPMAJOR} -eq 3 ] && [ ${GPPMINOR} -ge  3  ]; then
    GPPVER="GCC3.3"
elif [ ${GPPMAJOR} -eq 4 ]; then
    GPPVER="GCC4"
else # abandon ship!
    echo "Unsupported g++ version ${GPP_VERSION}"
    exit 1
fi

# set build target
case %{_arch} in
    ia64) TARGET=64 ;;
    x86_64) TARGET=64 ;;
    i[3456]86) TARGET=32 ;;
esac
echo "Using ${GPPVER} and build_${TARGET} target"

# build library and doxygen generated man pages
# as well as jni library and javadoc
ant -v -f build.xml \
    -DCCOVERRIDE=${CCOVERRIDE} \
    -DLDOVERRIDE=${LDOVERRIDE} \
    -Dplatform=Linux-${GPPVER} \
    deliver_java build_${TARGET} doxygen

popd

%install
rm -rf %{buildroot}
# jars
# remove stuff we don't ship
rm -f lib/junit*.jar
#and duplicates
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}
install -m 644 Java_XAM_Library/deliverables/xamlib.jar \
                Java_Interfaces/deliverables/snia-xam.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}

install -m 644 Java_Reference_VIM/deliverables/*.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}

install -m 644 lib/*.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}

#sample properties files

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}/conf_examples

install -m 644  Java_Reference_VIM/config/ReferenceVIM.config \
                Java_Reference_VIM/xam.test.props \
                $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}/conf_examples

# C_XAM_Library
# set g++ version >=3.3 or >=4.0
# build layout requires it
GPP_VERSION=`g++ --version|head -n 1|cut -d ' ' -f 3`
GPPMAJOR=`echo ${GPP_VERSION}|cut -d '.' -f 1`
GPPMINOR=`echo ${GPP_VERSION}|cut -d '.' -f 2`
if [  ${GPPMAJOR} -eq 3 ] && [ ${GPPMINOR} -ge  3  ]; then
    GPPVER="GCC3.3"
elif [ ${GPPMAJOR} -eq 4 ]; then
    GPPVER="GCC4"
else # abandon ship!
    echo "Unsupported g++ version ${GPP_VERSION}"
    exit 1
fi
# set build target
case %{_arch} in
    ia64) TARGET=64 ;;
    x86_64) TARGET=64 ;;
    i[3456]86) TARGET=32 ;;
esac
# read version major, minor rev
SDK_MAJOR=`grep "sdk.major" package.properties|cut -d '=' -f2`
SDK_MINOR=`grep "sdk.minor" package.properties|cut -d '=' -f2`
SDK_REV=`grep "sdk.rev" package.properties|cut -d '=' -f2`
FILE_EXT=${SDK_MAJOR}.${SDK_MINOR}.${SDK_REV}
SONAME_EXT=${SDK_MAJOR}

DELIVER_DIR=C_XAM_Library/deliverables/Linux-${GPPVER}
install -d -m 755 $RPM_BUILD_ROOT%{_includedir}/%{name}-%{version}
install -m 644 ${DELIVER_DIR}/include/*.h $RPM_BUILD_ROOT%{_includedir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_libdir}
install -m 644 ${DELIVER_DIR}/lib/libxam*.a $RPM_BUILD_ROOT%{_libdir}

install -m 755 ${DELIVER_DIR}/lib/libxam*.so $RPM_BUILD_ROOT%{_libdir}

install -d -m 755 $RPM_BUILD_ROOT%{_jnidir}
install -m 755 ${DELIVER_DIR}/lib/*.jar $RPM_BUILD_ROOT%{_jnidir}

# TODO
#install symlinks for user code linkage
pushd `pwd`
cd $RPM_BUILD_ROOT%{_libdir}
for i in `ls libxam*.so`; do
    mv $i $i.${FILE_EXT}
    # ldconfig should create this, but add anyway
    ln -s $i.${FILE_EXT} $i.${SONAME_EXT}
    ln -s $i.${SONAME_EXT} $i
done
#JNI jar
popd
pushd `pwd`
cd $RPM_BUILD_ROOT%{_jnidir}
mv XAMLibrary.jar XAMLibrary-${FILE_EXT}.jar
ln -s XAMLibrary-${FILE_EXT}.jar XAMLibrary.jar
popd


# C_XAM_Library man pages
gzip ${DELIVER_DIR}/doc/published-man/man3/*
install -d -m 755 $RPM_BUILD_ROOT%{_mandir}/man3
install -m 644 ${DELIVER_DIR}/doc/published-man/man3/*.gz $RPM_BUILD_ROOT%{_mandir}/man3


# javadoc
mv Java_Interfaces/doc Java_Interfaces/docs
JAVA_DOC_DIRS="Java_XAM_Library Java_Reference_VIM Java_Interfaces"
for i in ${JAVA_DOC_DIRS}; do
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-java-%{version}/$i;
cp -rp $i/docs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-java-%{version}/$i;
done

# C_XAM_Library jni doc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/C_XAM_Library_JNI;
cp -rp ${DELIVER_DIR}/doc/Published-Javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/C_XAM_Library_JNI;


# generic man pages
echo %{_mandir}
install -d -m 755 $RPM_BUILD_ROOT%{_mandir}/man5
install -d -m 755 $RPM_BUILD_ROOT%{_mandir}/man7

gzip Docs/man/man5/*
gzip Docs/man/man7/*
install -m 644 Docs/man/man5/*.gz $RPM_BUILD_ROOT%{_mandir}/man5;
install -m 644 Docs/man/man7/*.gz $RPM_BUILD_ROOT%{_mandir}/man7;

# general docs
cp Docs/LICENSE.txt ./LICENSE
cp Docs/README.txt ./README
cp Docs/XAM_SDK_Guide.pdf ./XAM_SDK_Guide.pdf
#############################

%clean
rm -rf %{buildroot}


# libraries and general doc
%files 
%defattr(-, root, root)
%doc README LICENSE XAM_SDK_Guide.pdf
%{_jnidir}/*.jar
%{_libdir}/libxam*.so.*
%{_mandir}/man5/*
%{_mandir}/man7/*

# headers and developer documentation
%files devel
%defattr(-, root, root)
%{_includedir}/%{name}-%{version}
%{_libdir}/libxam*.a
%{_libdir}/libxam*.so
%{_javadocdir}/%{name}-%{version}/*
%{_mandir}/man3/*


#  jar files and general doc
%files java
%defattr(-, root, root)
%doc README LICENSE XAM_SDK_Guide.pdf
%{_javadir}/*

# java developer documentation
%files javadoc
%defattr(-, root, root)
%{_javadocdir}/%{name}-java-%{version}/*
#############################

%post 
# update for dynamic linker
/sbin/ldconfig

%postun 
# update for dynamic linker
/sbin/ldconfig



%changelog
* Mon Feb 16 2009 Stuart Naisbitt <stuart.naisbitt@olocity.com> %{version}
- Add building of C_XAM_Library and C api man pages. Limit building of rpm to linux. Append distribution if set
* Mon Jan 26 2009 Stuart Naisbitt <stuart.naisbitt@olocity.com>
- Initial spec file
#############################
